/*
        displays.h

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file handles all of the data input and output:
	
		d_list()   allows the user to list data
		f_summ()   allows the user to summarize data 
*/
int check_more(int more)
{
	int check;
	more++;
	if(more == LINES -2 && ask_more == TRUE)
	{
		saystatus("-MORE-             ");
		check = ldwait();
		more = 0;
		saystatus("Data Display Mode  ");
		if(check == TRUE) return(-1);
	}
	return(more);
} 

void d_list (char coinput[MAX_INPUT])
{
	int count, scount, escapeloop, match, checkstop, more;
	char vname[MAX_VARS][DESC_LENGTH];
	int vartype[MAX_VARS];
	int varnumber[MAX_VARS];
	int varlength[MAX_VARS];
	int numbvars;
	numbvars = 1;
	escapeloop = FALSE;
	astart = 0;
	astop = MAX_OBS;
	checkstop = 0;
	saystatus("Data Display Mode  ");
	strcpy(vname[numbvars],puller(coinput));
	if(strlen(vname[numbvars])==0)
	{
		alert(error(2),alert_time);
		return;
	}
	while(escapeloop == FALSE)
	{
		numbvars++;
		strcpy(vname[numbvars],puller(coinput));
		if(strlen(vname[numbvars]) == 0) escapeloop = TRUE;
	}
	numbvars --;
	count = 1;
	while(count <= numbvars)
	{
		match = FALSE;
		for(scount=0;scount < MAX_VARS; scount++)
		{
			if(strcmp(vname[count],d_matrix[scount].v_name)==0 && strlen(d_matrix[scount].v_name) > 0) 
			{
				if(d_matrix[scount].fnumb != -1)
				{
					vartype[count] = 1;
					varnumber[count] = d_matrix[scount].fnumb;
					fvec[varnumber[count]]=d_matrix[scount].fmem_start;
					match = TRUE;
					if(checkstop < d_matrix[scount].nobs) checkstop = d_matrix[scount].nobs;
					varlength[count] = d_matrix[scount].nobs;
				}
				if(d_matrix[scount].inumb != -1)
				{
					vartype[count] = 2;
					varnumber[count] = d_matrix[scount].inumb;
					ivec[varnumber[count]]=d_matrix[scount].imem_start;
					match = TRUE;
					if(checkstop < d_matrix[scount].nobs) checkstop = d_matrix[scount].nobs;
					varlength[count] = d_matrix[scount].nobs;
				}
				if(d_matrix[scount].snumb != -1)
				{
					vartype[count] = 3;
					varnumber[count] = d_matrix[scount].snumb;
					match = TRUE;
					if(checkstop < d_matrix[scount].nobs) checkstop = d_matrix[scount].nobs;
					varlength[count] = d_matrix[scount].nobs;
				}
			}
		}
		if(match == FALSE)
		{
			if(strncmp(vname[count],"in",2) != 0)
			{
				alert(error(2),alert_time);
				return;
			}
			astart = atoi(vname[count + 1]) - 1;
			astop = atoi(vname[count  + 2]);
			if (astop < astart || astop <= 0 || astart < 0)
			{
				alert(error(27),alert_time);
				return;
			}
			numbvars = numbvars - 3; 
		}
		count++;
	}
	if(astop > checkstop) astop = checkstop;
	more = 0;
	wprintw(ioarea,"\n\n");
	wrefresh(ioarea);
	if(existslog == TRUE) fprintf(log_name,"\n\n");
	if(existstex == TRUE) 
	{
		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"\n\n\\midinsert\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"$$\\hbox{Table of Observations}$$\n");
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#&\\strut\\quad\\hfil#\\quad\\cr\n");
		fprintf(tex_name,"&obs\\hfil\t&");
		for(count = 1 ; count <= numbvars; count++)
		{
			fprintf(tex_name,"& %s\\hfil\t&",vname[count]);
		}
		fprintf(tex_name,"\\cr\n");
		fprintf(tex_name,"\\noalign{\\hrule}\n");
	}
	for(count = astart; count < astop; count++)
	{
		wprintw(ioarea,"%i\t", count + 1);
		wrefresh(ioarea);
		if(existslog == TRUE) fprintf(log_name,"%i\t", count + 1);
		if(existstex == TRUE) fprintf(tex_name,"& %i\t&", count + 1);
		for(scount = 1; scount <= numbvars; scount ++)
		{
			if(vartype[scount] == 1)
			{
				if(varlength[scount]>count) 
				{
					wprintw(ioarea,"%10.4f\t", *(fvec[varnumber[scount]] + count));
					if(existslog == TRUE) fprintf(log_name,"%10.4f\t", *(fvec[varnumber[scount]] + count));
					if(existstex == TRUE) fprintf(tex_name,"& %.4f\t&", *(fvec[varnumber[scount]] + count));
				}
				else 
				{
					wprintw(ioarea," -nobs- \t");
					wrefresh(ioarea);
					if(existslog == TRUE) fprintf(log_name," %i \t", missing_ob);
					if(existstex == TRUE) fprintf(tex_name,"&\t&");
				}
			}
			if(vartype[scount] == 2)
			{
				if(varlength[scount]>count) 
				{
					wprintw(ioarea,"%10i\t", *(ivec[varnumber[scount]] + count));
					if(existslog == TRUE) fprintf(log_name,"%10i\t", *(ivec[varnumber[scount]] + count));
					if(existstex == TRUE) fprintf(tex_name,"& %i\t&", *(ivec[varnumber[scount]] + count));
				}
				else 
				{
					wprintw(ioarea," -nobs- \t");
					wrefresh(ioarea);
					if(existslog == TRUE) fprintf(log_name," %i \t", missing_ob);
					if(existstex == TRUE) fprintf(tex_name,"&\t&");
				}
			}
			if(vartype[scount] == 3)
			{
				if(varlength[scount]>count) 
				{
					wprintw(ioarea,"%14s\t", smatrix[varnumber[scount]][count]);
					if(existslog == TRUE) fprintf(log_name,"%14s\t", smatrix[varnumber[scount]][count]);
					if(existstex == TRUE) fprintf(tex_name,"&%s\t&", smatrix[varnumber[scount]][count]);
				}
				else 
				{
					wprintw(ioarea," -nobs- \t");
					wrefresh(ioarea);
					if(existslog == TRUE) fprintf(log_name," %i \t", missing_ob);
					if(existstex == TRUE) fprintf(tex_name,"&\t&");
				}
			}
		}
		wprintw(ioarea,"\n");
		wrefresh(ioarea);
		if(existslog == TRUE) fprintf(log_name,"\n");
		if(existstex == TRUE) fprintf(tex_name,"\\cr\n");
		more = check_more(more);
		if(more < 0) count = astop;
	}
	if(existstex == TRUE)
	{
		fprintf(tex_name,"}\\hrule}$$\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"\\endinsert\n\n");
	}
}

void showstate (void)
{	
	int count, more;
	more = 10;
	saystatus("Display Info Mode  ");
	wprintw(ioarea,"\n\n     ldlas' Internal Memory State\n\n");
	wprintw(ioarea,"     Total  Variable Space: %i\n", MAX_VARS);
	wprintw(ioarea,"     String Variable Space: %i\n", MAX_SVARS);
	wprintw(ioarea,"            Constant Space: %i\n", MAX_CONS);
	wprintw(ioarea,"     Possible Observations: %i\n", MAX_OBS);
	wprintw(ioarea,"     Value for Missing Obs: %i\n\n", missing_ob);
	wprintw(ioarea,"     Variable                           Type/Number           \n");
	wprintw(ioarea,"  number  name                   float    integer   string    \n");
	wprintw(ioarea," ----------------------------------------------------------  \n");
	for(count=0;count < MAX_VARS; count++)
	{
		if(d_matrix[count].fnumb != -1 || d_matrix[count].inumb != -1 || d_matrix[count].snumb != -1)
		{
			wprintw(ioarea,"   %3i    %-20s  %5i  %7i   %7i  \n",	count,
							d_matrix[count].v_name,
				             		d_matrix[count].fnumb,
				             		d_matrix[count].inumb,
				             		d_matrix[count].snumb);
			more = check_more(more);
			if(more < 0) count = MAX_VARS;
		}
	wrefresh(ioarea);
	}
	wprintw(ioarea," ----------------------------------------------------------  \n");
	wprintw(ioarea," Please see the manual for an explanation.\n\n");
	wrefresh(ioarea);
	if(existslog == TRUE)
	{
		fprintf(log_name,"\n\n     ldlas' Internal Memory State\n\n");
		fprintf(log_name,"     Total  Variable Space: %i\n", MAX_VARS);
		fprintf(log_name,"     String Variable Space: %i\n", MAX_SVARS);
		fprintf(log_name,"            Constant Space: %i\n", MAX_CONS);
		fprintf(log_name,"     Possible Observations: %i\n", MAX_OBS);
		fprintf(log_name,"     Value for Missing Obs: %i\n\n", missing_ob);
		fprintf(log_name,"     Variable                           Type/Number           \n");
		fprintf(log_name,"  number  name                   float    integer   string    \n");
		fprintf(log_name," ----------------------------------------------------------  \n");
		for(count=0;count < MAX_VARS; count++)
		{
			if(d_matrix[count].fnumb != -1 || d_matrix[count].inumb != -1 || d_matrix[count].snumb != -1)
			{
				fprintf(log_name,"   %3i    %-20s  %5i  %7i   %7i  \n",	count,
							d_matrix[count].v_name,
				             		d_matrix[count].fnumb,
				             		d_matrix[count].inumb,
				             		d_matrix[count].snumb);
			}
		}
		fprintf(log_name," ----------------------------------------------------------  \n");
	}
	if(strlen(puller(coinput)) > 0) small_error(3);
}

char * reporttype (int count)
{
	if(d_matrix[count].fnumb != -1) return("float");
	if(d_matrix[count].inumb != -1) return("integer");
	if(d_matrix[count].snumb != -1) return("string");
	return("empty");
}

int count_constants(void)
{
	int count;
	int score;
	score = 0;
	for(count= 0; count < MAX_CONS; count++)
	{
		if(strlen(constants[count].c_name) > 1) score++;
	}
	return(score);
}

void describe (void)
{	
	int count, more;
	more = 4;
	saystatus("Describe Data Mode ");
	wprintw(ioarea,"\n\n%s\n\n",d_matrix_desc);
	wprintw(ioarea,"name                 Obs    Type     Description  \n");
	wprintw(ioarea,"-------------------------------------------------------------------------------\n");
	for(count=0;count < MAX_VARS; count++)
	{
		if(d_matrix[count].nobs > 0)
		{
			wprintw(ioarea,"%-20s  %-5i %-7s  %-40s\n",	d_matrix[count].v_name,
								d_matrix[count].nobs,
								reporttype(count),
								d_matrix[count].v_desc);
			wrefresh(ioarea);
			more=check_more(more);
			if(more < 0) count = MAX_VARS;
		}
	}
	wprintw(ioarea,"-------------------------------------------------------------------------------\n");
	wrefresh(ioarea);
	wprintw(ioarea," There are %i constants defined.\n\n",count_constants());
	wrefresh(ioarea);
	if(existslog == TRUE)
	{	
		fprintf(log_name,"\n\n%s\n\n",d_matrix_desc);
		fprintf(log_name,"name                 Obs    Type     Description  \n");
		fprintf(log_name,"-------------------------------------------------------------------------------\n");
		for(count=0;count < MAX_VARS; count++)
		{
			if(d_matrix[count].nobs > 0)
			{
				fprintf(log_name,"%-20s  %-5i %-7s  %-40s\n",	d_matrix[count].v_name,
								d_matrix[count].nobs,
								reporttype(count),
								d_matrix[count].v_desc);
			}
		}
		fprintf(log_name,"-------------------------------------------------------------------------------\n");
		fprintf(log_name," There are %i constants defined.\n\n",count_constants());
	}
	if(existstex == TRUE)
	{
		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"\n\n\\midinsert\n");
		fprintf(tex_name,"\\bigskip\n");
		if(strlen(d_matrix_desc) > 0) fprintf(tex_name,"$$\\hbox{%s}$$\n",d_matrix_desc);
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#\\hfil&\\strut\\quad\\hfil#\\hfil\\quad\\cr\n");
		fprintf(tex_name,"& Name && Obs && Type && Description &\\cr\n");
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		for(count=0;count < MAX_VARS; count++)
		{
			if(d_matrix[count].nobs > 0)
			{
				fprintf(tex_name,"& %-20s && %-5i && %-7s  && %-40s &\\cr\n",	d_matrix[count].v_name,
												d_matrix[count].nobs,
												reporttype(count),
												d_matrix[count].v_desc);
			}
		}
		fprintf(tex_name,"}\\hrule}$$\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"\\endinsert\n\n");
	}
	if(strlen(puller(coinput)) > 0) small_error(3);
}

void ldecho (char coinput[MAX_INPUT])
{
	wprintw(ioarea,"\n%s",coinput);
	wrefresh(ioarea);
	if(existslog == TRUE) fprintf(log_name,"%s\n",coinput);
	if(existstex == TRUE) fprintf(tex_name,"%s\n",coinput);
}
