/*      dobatch.h  

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file includes routines to handle batch processes such as do()
	as well as all the related commands including:	query()
							set()
							echo()
	
*/

void display_time (void)
{
	wprintw(ioarea,"\n The time is %s", ctime());
	if(existslog == TRUE) fprintf(log_name,"\n The time is %s\n", ctime());
	if(existstex == TRUE) fprintf(tex_name,"\n\n%%\n%%   The time is %s\n%%\n\n", ctime());
}

void set(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT];
	long temp;
	int nevermind;
	int check = 1;
	nevermind = FALSE;
	strcpy(token,puller(coinput));
	if(strncmp(token,"more",strlen(token))==0 && strlen(token) > 0)
	{
		strcpy(token,puller(coinput));
		if(strncmp(token,"on",2)==0)
		{
			ask_more = TRUE;
		}
		if(strncmp(token,"off",3)==0)
		{
			ask_more = FALSE;
		}
		if(strncmp(token,"on",2) != 0 && strncmp(token,"off",3) != 0) check = 0;
	}
	if(strncmp(token,"graphform",strlen(token)) == 0 && strlen(token) > 0)
	{
		if(strlen(coinput) < 1)
		{
			alert(error(20), alert_time);
			strcpy(graphform,"DEF_GRAPHFORM");
			return;
		}
		nevermind = TRUE;
		strcpy(graphform,puller(coinput));
		strcat(graphform,coinput);
	}
	if(strncmp(token,"lineform",strlen(token)) == 0 && strlen(token) > 0)
	{
		strcpy(token,puller(coinput));
		lineform = atoi(token);
		if(lineform < 0) lineform = 0;
		if(lineform > 6) lineform = 6;
	}
	if(strncmp(token,"keyform",strlen(token)) == 0 && strlen(token) > 0)
	{
		strcpy(token,puller(coinput));
		keyform = atoi(token);
		if(keyform < 0) keyform = 0;
		if(keyform > 3) keyform = 3;
	}
	if(strncmp(token,"keyscale",strlen(token)) == 0 && strlen(token) > 0)
	{
		strcpy(token,puller(coinput));
		keyscale = atof(token);
		if(keyscale < 0) keyscale = 0;
		if(keyscale > 1) keyscale = 1;
	}
	if(strncmp(token,"pointform",strlen(token)) == 0 && strlen(token) > 0)
	{
		strcpy(token,puller(coinput));
		pointform = atoi(token);
		if(pointform < 0) pointform = 0;
		if(pointform > 6) pointform = 6;
	}
	if(strncmp(token,"missing",strlen(token))==0 && strlen(token) > 0)
	{
		if(strlen(coinput) < 1)
		{
			alert(error(20), alert_time);
			return;
		}
		strcpy(token,puller(coinput));
		missing_ob = atoi(token);
		oktoquit = FALSE;
	}
	if(check == 0)
	{
		alert(error(20),alert_time);
		return;
	}
	if(strlen(token) < 1)
	{
		wprintw(ioarea,"\n\n");
		wrefresh(ioarea);
		wprintw(ioarea,"      missing observation: %i\n",missing_ob);
		if(ask_more == TRUE)
		{
			wprintw(ioarea,"                     more: on\n");
		}
		else
		{
			wprintw(ioarea,"                     more: off\n");
		}
		wrefresh(ioarea);
		wprintw(ioarea,"    Save graphs in format: %s\n",graphform);
		wrefresh(ioarea);
		wprintw(ioarea,"    Line format in graphs: %i\n",lineform);
		wrefresh(ioarea);
		wprintw(ioarea,"   Point format in graphs: %i\n",pointform);
		wrefresh(ioarea);
		wprintw(ioarea,"  Key placement in graphs: %i\n",keyform);
		wrefresh(ioarea);
		wprintw(ioarea,"       Key scaling factor: %f\n",keyscale);
		wrefresh(ioarea);
	}
	if(strlen(coinput) > 1 && nevermind == FALSE) small_error(3);
}



void dobatch(char coinput[MAX_INPUT])
{
	char scratch[MAX_INPUT];
	if(batchmode == TRUE)
	{
		alert(error(41),alert_time);
	}
	saystatus("Batch File Mode    ");
	strcpy(batchname,puller(coinput));
	if(!strchr(batchname,'.')) strcat(batchname,".ldo");
	batch_name = fopen(batchname,"r");
	if(!batch_name)
	{
		strcpy(scratch,"/usr/lib/ldlas/tut/");
		strcat(scratch,batchname);
		batch_name = fopen(scratch,"r");
		if(!batch_name)
		{
			alert(error(43),alert_time);
			return;
		}
	}
	batchmode = TRUE;
}

void batch_input (char coinput[MAX_INPUT])
{
	int count;
	saystatus("Batch File Mode    ");
	for(count = 0; count < MAX_INPUT; count++)
	{
		coinput[count]=fgetc(batch_name);
		if(coinput[count] == '\n')
		{
			coinput[count] = '\0';
			count = MAX_INPUT;
		}
		if(feof(batch_name) != 0)
		{
			coinput[count] = '\0';
			count = MAX_INPUT;
		}
	}
	if(feof(batch_name) != 0) 
	{
		batchmode = FALSE;
		fclose(batch_name);
	}
	if(coinput[0] == '#') coinput[0] = '\0';
}

/* void ldquery(char coinput[MAX_INPUT])
{
	wprintw(ioarea,"\n NYF: ldquery");
	wrefresh(ioarea);
}*/

