/*      errors.h  

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file returns error message strings
	
*/

char *error(int enumber)
{
	strcpy(coinput,"\0");
	switch (enumber)
	{
/*          TEMPLATE              return("\n     ERROR: B                                           E      B                                              E     */
		case 1	: beep(); return("\n     ERROR: Can't quit with unsaved data in memory.");
		case 2	: beep(); return("\n     ERROR: Bad variable specification.");
		case 3	: beep(); return("\n     ERROR: No room to add more variables.");
		case 4	: beep(); return("\n     ERROR: No more memory available for variables.");
		case 5	: beep(); return("\n     ERROR: No room to add more string variables.");
		case 6	: beep(); return("\n     ERROR: There is no data in memory to drop.");
		case 7	: beep(); return("\n     ERROR: \"label\" must be followed by \"data\" or                   \"variable\" and the name of an existing                  variable. ");
		case 8	: beep(); return("\n     ERROR: Could not create requested file.");
		case 9	: beep(); return("\n     ERROR: This data file cannot be loaded because it              was created with a bigger version of ldlas.");
		case 10	: beep(); return("\n     ERROR: Data input is screwed up and out of sync.               Probably a bad input file.");
		case 11	: beep(); return("\n     ERROR: You have to drop/save data in memory before             loading new data.");
		case 12	: beep(); return("\n     ERROR: Cannot find the specified input file.");
		case 13 : beep(); return("\n     ERROR: Cannot drop variable as it does not exist.");
		case 14 : beep(); return("\n     ERROR: Variable name already exists.");
		case 15 : beep(); return("\n     ERROR: Missing name for variable or ambiguous name.            Variable names cannot begin with \"integer\",              \"float\", or \"string\"");
		case 16 : beep(); return("\n     ERROR: Cannot summarize a string variable");
		case 17 : beep(); return("\n     ERROR: Alert must be set to an integer greater than            zero.");
		case 18 : beep(); return("\n     ERROR: Nothing to set.");
		case 19 : beep(); return("\n     ERROR: Variable names cannot begin with numeric                characters.");
		case 20 : beep(); return("\n     ERROR: Bad \"set\" syntax. See \"help set\" for a                  description of the set command.");
		case 21 : beep(); return("\n     ERROR: Turn existing log file off before opening a             new one.");
		case 22 : beep(); return("\n     ERROR: No log file to turn off.");
		case 23 : beep(); return("\n     ERROR: \"log\" must be followed by \"on {filename}\" or            \"off\"");
		case 24 : beep(); return("\n     ERROR: Turn existing tex log file off before                   opening a new one.");
		case 25 : beep(); return("\n     ERROR: No tex log file to turn off.");
		case 26 : beep(); return("\n     ERROR: \"texlog\" must be followed by \"on {filename}\"            or \"off\"");
		case 27 : beep(); return("\n     ERROR: Bad specification of \"in\" boundaries");
		case 28 : beep(); return("\n     ERROR: The tutorial is invoked with \"do tutorial\"");
		case 29 : beep(); return("\n     ERROR: \"in\" is an optional extension to some                   commands, not a command in and of itself.");
		case 30 : beep(); return("\n     ERROR: \"more\" is handled via the \"set\" command.");
		case 31 : beep(); return("\n     ERROR: \"missing\" is handled via the \"set\" command.");
		case 32 : beep(); return("\n     ERROR: The child process (\"shell\" command) failed");
		case 33 : beep(); return("\n     ERROR: Can't initiate requested shell command");
		case 34 : beep(); return("\n     ERROR: Can't plot string data");
		case 35 : beep(); return("\n     ERROR: Bad variable specification or bad option in             graph command");
		case 36 : beep(); return("\n     ERROR: The \"graph\" command requires at least two               variables.");
		case 37 : beep(); return("\n     ERROR: Please specify each variable only once.");
		case 38 : beep(); return("\n     ERROR: Can't do a histogram of a string variable.");
		case 39 : beep(); return("\n     ERROR: Bad variable or option to \"histogram\".");
		case 40 : beep(); return("\n     ERROR: Cannot draw a histogram of a variable with              no variation.");
		case 41 : beep(); return("\n     ERROR: You can't call a batch file from within a               batch file.");
		case 42	: beep(); return("\n     ERROR: ldlas has reached the end of conditional                loop that it shouldn't have. Please send a              bug report to the author.");
		case 43	: beep(); return("\n     ERROR: Can't find requested \".ldo\" file.");
		case 44	: beep(); return("\n     ERROR: No variables to input.");
		case 45 : beep(); return("\n     ERROR: You must supply a new name.");
		case 46 : beep(); return("\n     ERROR: The \"new\" name supplied is already in use.");
		case 47 : beep(); return("\n     ERROR: Nothing to drop.");
		case 48 : beep(); return("\n     ERROR: You must supply a file name");
		case 49 : beep(); return("\n     ERROR: No such constant.");
		case 50 : beep(); return("\n     ERROR: Constants must begin with an underscore.");
		case 51 : beep(); return("\n     ERROR: Constant already exists.");
		case 52 : beep(); return("\n     ERROR: No more room to add constants.");
		case 53 : beep(); return("\n     ERROR: Variable names must begin with a letter.");
		case 54 : beep(); return("\n     ERROR: Bad variable or option to \"interpolate\".");
		case 55 : beep(); return("\n     ERROR: I'm not smart enough to interpolate string              data.");
		case 56 : beep(); return("\n     ERROR: Can't start interpolating at a missing                  value.");
		case 57 : beep(); return("\n     ERROR: Can't end interpolating at a missing value.");
		case 58 : beep(); return("\n     ERROR: No missing values to interpolate.");
		case 59 : beep(); return("\n     ERROR: Number of observations after fappend would              be too large. Trying to succesfully                      truncate.");
		case 60 : beep(); return("\n     ERROR: Variable mismatch. You cannot \"fappend\"                 variables with the same name but different             types.");
		case 61 : beep(); return("\n     ERROR: Variable must already exist to be appended              to.");
		case 62 : beep(); return("\n     ERROR: Can't use string variables in regressions.");
		case 63 : beep(); return("\n     ERROR: Bad variable specification to \"regress\".");
		case 64 : beep(); return("\n     ERROR: Not enough free memory to perform task.");
		case 65 : beep(); return("\n     ERROR: Need at least one independent and one                   dependent variable.");
		case 66 : beep(); return("\n     ERROR: At least one variable needs more non-missing            observations.");
		case 67 : beep(); return("\n     ERROR: The regression matrix is singular. Trying               changing/perturbing independent variables.");
		case 68 : beep(); return("\n     ERROR: Incorrect or disliked input to \"calculate\".");
		case 69 : beep(); return("\n     ERROR: Nothing to generate.");
		case 70 : beep(); return("\n     ERROR: Incorrect or disliked input to \"generate\".");
		case 71 : beep(); return("\n     ERROR: Bad expression for index.");
		case 72 : beep(); return("\n     ERROR: Cannot replace unknown variable.");
		case 73 : beep(); return("\n     ERROR: I'm not smart enough to replace a string                variable.");
		case 74 : beep(); return("\n     ERROR: Nothing to predict. Have you run a                      regression yet?");
		case 75 : beep(); return("\n     ERROR: Insufficient degrees of freedom to regress.");
		case 76 : beep(); return("\n     ERROR: I'm not smart enough to be able to extrapolate          a string variable.");
		case 77 : beep(); return("\n     ERROR: Bad syntax to \"extrapolate\"");
		case 78 : beep(); return("\n     ERROR: You need less lags or a longer variable.");
		case 99 : beep(); return("\n     ERROR: Unkown error. How did you do that?");
	}
}

/*   Small errors are those which would be anoying to have a new window for */

void small_error(int enumber)
{
	switch (enumber)
	{
		case 1	: beep(); loutput("\nERROR: Ambiguous abbreviation or no such command");break;
		case 2  : beep(); loutput("\nERROR: Bad start/stop values. Setting to defaults");break;
		case 3  : beep(); loutput("\nERROR: Extra input ignored.");break;
		case 99 : beep(); loutput("\nERROR: Unkown error. How did you do that?");break;
	}
}

void check_in (char coinput[MAX_INPUT])
{
	int tempstart, tempstop;
	if (strncmp(puller(coinput),"in",2) != 0) return;
	tempstart = atoi(puller(coinput));
	tempstop = atoi(puller(coinput));
	if (tempstop < tempstart || tempstop <= 0 || tempstart <= 0)
	{
		small_error(2);
		return;
	}
	astart = tempstart - 1;
	astop = tempstop;
}


