/*      interact.h  

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file includes routines to interact with shell commands
*/


void ls_dir (char coinput[MAX_INPUT])
{
	char herb[MAX_INPUT];
	char lsflags[MAX_INPUT];
	char whatdir[MAX_INPUT];
	FILE *fdopen(), *fp;
	int pid, escapeloop, more;
	int p[2];
	saystatus("Directory Display  ");
	strcpy(lsflags,puller(coinput));
	strcpy(whatdir,puller(coinput));
	pipe(p);
	escapeloop = FALSE;
	more = 0;
	switch (pid = fork())
	{
		case 0 :	close(WRITE); dup(p[WRITE]); close(p[WRITE]);
				if(strlen(whatdir) > 0) execlp("ls", "ls", lsflags, whatdir, 0);
				if(strlen(lsflags) > 0) execlp("ls", "ls", "-C", lsflags, 0);
				execlp("ls", "ls", "-C", 0);
				alert(error(32),alert_time);  
				return;
				
		case -1:	alert(error(33),alert_time);
				return;
				
		default:	fp = fdopen(p[READ],"r");
				close(p[WRITE]);
	}
	wprintw(ioarea,"\n\nContents:\n\n");
	wrefresh(ioarea);
	while(!feof(fp))
	{
		strcpy(herb,"\0");
		fgets(herb, 80, fp);
		wprintw(ioarea,"%s", herb);
		wrefresh(ioarea);
		more = check_more(more);
		if(more < 0)
		{
			wait(0);
			fclose(fp);
			close(p[READ]);
			return;
		}
		saystatus("Directory Display  ");
	}
	wprintw(ioarea,"\n");
	wrefresh(ioarea);
	wait(0);
	fclose(fp);
	close(p[READ]);
}

void histogram(char coinput[MAX_INPUT])
{
	WINDOW *graphbox;
	FILE *fdopen(), *fp, *datafile, *commandfile;
	char herb;
	char varname[MAX_INPUT];
	char token[MAX_INPUT];
	int count, scount, match, normal, freq, lims, legit, pid;
	int p[2];
	int grid;
	float xcord, ycord, average, running, variance, runningt;
	float bars;
	char graphtitle[MAX_INPUT];
	char xtitle[MAX_INPUT];
	char ytitle[MAX_INPUT];
	char xrange[MAX_INPUT];
	char xtics[MAX_INPUT];
	char yrange[MAX_INPUT];
	char ytics[MAX_INPUT];
	char savename[MAX_INPUT];
	strcpy(varname,puller(coinput));
	saystatus("Generating Plot...");
	match = TRUE;
	normal = FALSE;
	freq = FALSE;
	grid = FALSE;
	lims = FALSE;
	bars = 7;
	strcpy(graphtitle,"\0");
	strcpy(xtitle,"\0");
	strcpy(ytitle,"\0");
	strcpy(xrange,"\0");
	strcpy(yrange,"\0");
	strcpy(xtics,"\0");
	strcpy(ytics,"\0");
	strcpy(savename,"\0");
	while(match == TRUE)
	{
		strcpy(token,puller(coinput));
		legit = FALSE;
		if(strlen(token) < 1) match = FALSE;
		else
		{
			if(strncmp(token,"in",strlen(token)) == 0 && strlen(token) > 0)
			{
				legit = TRUE;
				astart = atoi(puller(coinput)) - 1;
				astop = atoi(puller(coinput));
				if(astart < 0 || astop < 1 || astop < astart)
				{
					alert(error(27),alert_time);
					return;
				}
				lims = TRUE;
			}
			if(strncmp(token,"normal",strlen(token)) == 0 && strlen(token) > 0)
			{
				legit = TRUE;
				normal = TRUE;
			}
			if(strncmp(token,"frequency",strlen(token)) == 0 && strlen(token) > 0)
			{
				legit = TRUE;
				freq = TRUE;
			}
			if(strncmp(token,"bars",strlen(token)) == 0 && strlen(token) > 0)
			{
				legit = TRUE;
				bars = atoi(puller(coinput));
				if(bars < 1)
				{
					alert(error(39), alert_time);
					return;
				}
			}
			if(strncmp(token,"grid",strlen(token)) == 0 && strlen(token) > 0)
			{
				legit = TRUE;
				grid = TRUE;
			}
			if(strncmp(token,"title",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(graphtitle,puller(coinput));
				legit = TRUE;
			}
			if(strncmp(token,"xtitle",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(xtitle,puller(coinput));
				legit = TRUE;
			}
			if(strncmp(token,"ytitle",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(ytitle,puller(coinput));
				legit = TRUE;
			}
			if(strncmp(token,"xrange",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(xrange,"[");
				strcat(xrange,puller(coinput));
				strcat(xrange,":");
				strcat(xrange,puller(coinput));
				strcat(xrange,"] ");
				legit = TRUE;
			}
			if(strncmp(token,"yrange",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(yrange,"[");
				strcat(yrange,puller(coinput));
				strcat(yrange,":");
				strcat(yrange,puller(coinput));
				strcat(yrange,"] ");
				legit = TRUE;
			}
			if(strncmp(token,"xtics",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(xtics,puller(coinput));
				legit = TRUE;
			}
			if(strncmp(token,"ytics",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(ytics,puller(coinput));
				legit = TRUE;
			}
			if(strncmp(token,"saving",strlen(token)) == 0 && strlen(token) > 0)
			{
				strcpy(savename,puller(coinput));
				legit = TRUE;
			}
			if(legit == FALSE)
			{
				alert(error(38), alert_time);
				return;
			}
		}
	}
	match == FALSE;
	for(count=0;count < MAX_VARS; count++)
	{
		if(strcmp(varname,d_matrix[count].v_name)==0 && strlen(d_matrix[count].v_name) > 0) 
		{
			if(d_matrix[count].fnumb != -1)
			{
				match = TRUE;
				fvec[d_matrix[count].fnumb]=d_matrix[count].fmem_start;
				if(lims == FALSE)
				{
					astart = 0;
					astop = d_matrix[count].nobs;
				}
				if(astop > d_matrix[count].nobs) astop = d_matrix[count].nobs;
				fsort(fvec[d_matrix[count].fnumb]);
			}
			if(d_matrix[count].inumb != -1)
			{
				match = TRUE;
				ivec[d_matrix[count].inumb]=d_matrix[count].imem_start;
				if(lims == FALSE)
				{
					astart = 0;
					astop = d_matrix[count].nobs;
				}
				if(astop > d_matrix[count].nobs) astop = d_matrix[count].nobs;
				astart = 0;
				astop = d_matrix[count].nobs;
				isort(ivec[d_matrix[count].inumb]);
			}
			if(d_matrix[count].snumb != -1)
			{
				alert(error(38), alert_time);
				return;
			}
		}
	if(match == TRUE) count = MAX_VARS;
	}
	if(match == FALSE)
	{
		alert(error(39), alert_time);
		return;
	}
	if(working[1] == working[worksize])
	{
		alert(error(40),alert_time);
		return;
	}
	xcord=working[1];
	datafile = fopen("/tmp/lddata","w");
	for(count = 1; count <= bars; count++)
	{
		ycord = 0;
		for(scount = 1;scount <= worksize;scount++)
		{
			if(working[scount] >= working[1] + (count - 1) * ((working[worksize] - working[1]) / bars) && working[scount] < working[1] + (count * ((working[worksize] - working[1]) / bars))) ycord++;
		}
		if(count == bars) ycord++;
		fprintf(datafile,"%f  0.00\n", xcord);
		if(freq == TRUE)
		{
			fprintf(datafile,"%f   %f\n", xcord, ycord / worksize);
			xcord = xcord + ((working[worksize] - working[1]) / bars);
			fprintf(datafile,"%f   %f\n", xcord, ycord / worksize);
		}
		else
		{
			fprintf(datafile,"%f   %f\n", xcord, ycord);
			xcord = xcord + ((working[worksize] - working[1]) / bars);
			fprintf(datafile,"%f   %f\n", xcord, ycord);
		}
		fprintf(datafile,"%f   %f\n",xcord, 0);
	}
	fclose(datafile);
	commandfile = fopen("/tmp/gnucoms", "w");
	fprintf(commandfile,"set term dumb %d %d\n", COLS - 1, LINES - 1);
	fprintf(commandfile,"set tics out\n");
	fprintf(commandfile,"set nokey\n");
	if(strlen(graphtitle) > 0) 
	{
		strcpy(graphtitle,add_blanks(graphtitle));
		fprintf(commandfile,"set title \"%s\"\n", graphtitle);
	}
	if(strlen(xtitle) > 0) 
	{
		strcpy(xtitle,add_blanks(xtitle));
		fprintf(commandfile,"set xlabel \"%s\"\n", xtitle);
	}
	if(strlen(ytitle) > 0) 
	{
		strcpy(ytitle,add_blanks(ytitle));
		fprintf(commandfile,"set ylabel \"%s\"\n", ytitle);
	}
	if(strlen(xrange) > 0) fprintf(commandfile,"set xrange %s \n",xrange);
	if(strlen(yrange) > 0) fprintf(commandfile,"set yrange %s \n",yrange);
	if(strlen(xtics) > 0) fprintf(commandfile,"set xtics %s \n",xtics);
	if(strlen(ytics) > 0) fprintf(commandfile,"set ytics %s \n",ytics);
	if(grid == TRUE) fprintf(commandfile,"set grid\n");
	if(normal == FALSE)
	{
		fprintf(commandfile,"plot \"/tmp/lddata\" with lines\n");
	}
	else 
	{
		running = 0;
		runningt = 0;
		for(count = 0; count < worksize; count++)
		{
			running = running + working[count];
			runningt = runningt + (working[count] * working[count]);
		}
		average = running / worksize;
		variance = (runningt / worksize) - (average * average);
		fprintf(commandfile,"plot \"/tmp/lddata\" with lines, ((exp(-0.5 * (((x - %f) / sqrt(%f)) * ((x - %f) / sqrt(%f))))) / (sqrt(%f) * sqrt(6.2831853))) * %f \n",average,variance,average,variance,variance, working[worksize] - working[1]);
	}
	if(strlen(savename) > 0)
	{
		fprintf(commandfile,"set term %s\n", graphform);
		fprintf(commandfile,"set output \"%s\" \n", savename);
		fprintf(commandfile,"replot\n");
	}
	fclose(commandfile);
	pipe(p);
	switch (pid = fork())
	{
		case 0 :	close(WRITE); dup(p[WRITE]); close(p[WRITE]);
				execl("/usr/bin/gnuplot", "gnuplot", "/tmp/gnucoms", 0);
				alert(error(32),alert_time);  
				return;
				break;
				
		case -1:	alert(error(33),alert_time);
				return;
				break;
				
		default:	fp = fdopen(p[READ],"r");
				close(p[WRITE]);
				break;
	}
	saystatus("Plot Preview       ");
	graphbox=newwin(LINES-1,COLS,0,0);
	touchwin(graphbox);
	wrefresh(graphbox);
	while(!feof(fp))
	{
		herb = fgetc(fp);
		if((herb > 31 && herb < 126) || herb == '\n') wprintw(graphbox,"%c", herb);
	}
	wrefresh(graphbox);
	ldwait();
	wait(0);
	fclose(fp);
	close(p[READ]);
	wclear(graphbox);
	wrefresh(graphbox);
	delwin(graphbox);
	refresh();
	system("rm /tmp/lddata");
	system("rm /tmp/gnucoms"); 
}

void ldgraph(char coinput[MAX_INPUT])
{
	WINDOW *graphbox;
	char herb;
	char lsflags[MAX_INPUT];
	char whatdir[MAX_INPUT];
	char vname[MAX_VARS][DESC_LENGTH];
	char graphtitle[MAX_INPUT];
	char xtitle[MAX_INPUT];
	char xrange[MAX_INPUT];
	char xtics[MAX_INPUT];
	char yrange[MAX_INPUT];
	char ytics[MAX_INPUT];
	char ytitle[MAX_INPUT];
	int vartype[MAX_VARS];
	int varlength[MAX_VARS];
	int varnumber[MAX_VARS];
	char savename[MAX_INPUT];
	int line[MAX_VARS];
	int point[MAX_VARS];
	int key, grid;
	FILE *fdopen(), *fp, *datafile, *commandfile;
	int pid, escapeloop, more, nloops, numbvars, count, match;
	int scount, tcount, checkstop;
	float bigx,smallx,bigy,smally;
	int p[2];
	saystatus("Generating Plot...");
	escapeloop = FALSE;
	strcpy(graphtitle,"\0");
	strcpy(xtitle,"\0");
	strcpy(ytitle,"\0");
	strcpy(xrange,"\0");
	strcpy(yrange,"\0");
	strcpy(xtics,"\0");
	strcpy(ytics,"\0");
	strcpy(savename,"\0");
	more = 0;
	astart = 0;
	astop = MAX_OBS;
	checkstop = 0;
	numbvars = 1;
	key = keyform;
	grid = FALSE;
	datafile = fopen("/tmp/lddata","w");
	strcpy(vname[numbvars],puller(coinput));
	if(strlen(vname[numbvars])==0)
	{
		alert(error(2),alert_time);
		return;
	}
	while(escapeloop == FALSE)
	{
		numbvars++;
		strcpy(vname[numbvars],puller(coinput));
		if(strlen(vname[numbvars]) == 0) escapeloop = TRUE;
	}
	numbvars --;
	nloops = numbvars;
	count = 1;
	numbvars = 0;
	while(count <= nloops)
	{
		for(scount=0;scount < MAX_VARS; scount++)
		{
			if(strcmp(vname[count],d_matrix[scount].v_name)==0 && strlen(d_matrix[scount].v_name) > 0) 
			{
				if(d_matrix[scount].fnumb != -1)
				{
					numbvars++;
					vartype[count] = 1;
					varnumber[count] = d_matrix[scount].fnumb;
					fvec[varnumber[count]]=d_matrix[scount].fmem_start;
					if(checkstop < d_matrix[scount].nobs) checkstop = d_matrix[scount].nobs;
					varlength[count] = d_matrix[scount].nobs;
				}
				if(d_matrix[scount].inumb != -1)
				{
					numbvars++;
					vartype[count] = 2;
					varnumber[count] = d_matrix[scount].inumb;
					ivec[varnumber[count]]=d_matrix[scount].imem_start;
					if(checkstop < d_matrix[scount].nobs) checkstop = d_matrix[scount].nobs;
					varlength[count] = d_matrix[scount].nobs;
				}
				if(d_matrix[scount].snumb != -1)
				{
					alert(error(34), alert_time);
					return;
				}
				line[count]=lineform;
				point[count]=pointform;
			}
		}
	count++;
	}
	count = numbvars + 1;
	while(count <= nloops)
	{
		match = FALSE;
		if(strncmp(vname[count],"in",2) == 0)
		{
			astart = atoi(vname[count + 1]) - 1;
			astop = atoi(vname[count  + 2]);
			if (astop < astart || astop <= 0 || astart < 0)
			{
				alert(error(27),alert_time);
				return;
			}
			count++;count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"lines",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			for(tcount = 1; tcount <= strlen(vname[count + 1]); tcount++)
			{
				line[tcount] = vname[count + 1][tcount - 1] - 48;
				if(line[tcount] < 0) line[tcount] = 0;
				if(line[tcount] > 6) line[tcount] = 6;
			}
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"title",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(graphtitle,vname[count + 1]);
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"xtitle",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(xtitle,vname[count + 1]);
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"grid",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			grid = TRUE;
			count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"ytitle",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(ytitle,vname[count + 1]);
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"xrange",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(xrange,"[");
			strcat(xrange,vname[count + 1]);
			strcat(xrange,":");
			strcat(xrange,vname[count + 2]);
			strcat(xrange,"] ");
			count++;count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"yrange",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(yrange,"[");
			strcat(yrange,vname[count + 1]);
			strcat(yrange,":");
			strcat(yrange,vname[count + 2]);
			strcat(yrange,"] ");
			count++;count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"xtics",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(xtics,vname[count + 1]);
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"ytics",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(ytics,vname[count + 1]);
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"saving",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			strcpy(savename,vname[count + 1]);
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"key",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			key = atoi(vname[count + 1]);
			if(key < 0) key = 0;
			if(key > 3) key = 3;
			count++;count++;
			match = TRUE;
		}
		if(strncmp(vname[count],"points",strlen(vname[count])) == 0 && strlen(vname[count]) > 0)
		{
			for(tcount = 1; tcount <= strlen(vname[count + 1]); tcount++)
			{
				point[tcount] = vname[count + 1][tcount - 1] - 48;
				if(point[tcount] < 0) point[tcount] = 0;
				if(point[tcount] > 6) point[tcount] = 6;
			}
			count++;count++;
			match = TRUE;
		}
		if(match == FALSE)
		{
			alert(error(35),alert_time);
			return;
		}
	}
	if(numbvars < 2)
	{
		alert(error(36), alert_time);
		return;
	}
	for(count = 1; count <= numbvars; count++)
	{
		for(scount = count + 1; scount <= numbvars; scount++)
		{
			if(strcmp(vname[count],vname[scount]) == 0)
			{
				alert(error(37), alert_time);
				return;
			}
		}
	}
	if(astop > checkstop) astop = checkstop;
	for(count = 0; count < astart; count++)
	{
		for(scount = numbvars; scount >= 1; scount --)
		{
			if(vartype[scount] == 1)
			{
				if(varlength[scount]>count) 
				{
					fvec[varnumber[scount]]++;
				}
			}
			if(vartype[scount] == 2)
			{
				if(varlength[scount]>count) 
				{
					ivec[varnumber[scount]]++;
				}
			}
		}
	}	
	if(vartype[numbvars] == 1)
	{
		fsort(fvec[varnumber[numbvars]]);
		bigx = working[worksize / 2 + 1];
		smallx = bigx;
	}
	else
	{
		isort(ivec[varnumber[numbvars]]);
		bigx = working[worksize / 2 + 1];
		smallx = bigx;
	}
	if(vartype[numbvars - 1] == 1)
	{
		fsort(fvec[varnumber[numbvars - 1]]);
		bigy = working[worksize / 2 + 1];
		smally = bigy;
	}
	else
	{
		isort(ivec[varnumber[numbvars - 1]]);
		bigy = working[worksize / 2 + 1];
		smally = bigy;
	}
	for(count = astart; count < astop; count++)
	{
		for(scount = numbvars; scount >= 1; scount --)
		{
			if(vartype[scount] == 1)
			{
				if(varlength[scount]>count) 
				{
					if(*fvec[varnumber[scount]] == missing_ob) fprintf(datafile,"  ;  ");
					else
					{
						fprintf(datafile,"%f ", *fvec[varnumber[scount]]);
						if(bigy < *fvec[varnumber[scount]] && scount != numbvars) bigy = *fvec[varnumber[scount]];
						if(smally > *fvec[varnumber[scount]] && scount != numbvars) smally = *fvec[varnumber[scount]];
						if(bigx < *fvec[varnumber[scount]] && scount == numbvars) bigx = *fvec[varnumber[scount]];
						if(smallx > *fvec[varnumber[scount]] && scount == numbvars) smallx = *fvec[varnumber[scount]];
					}
					fvec[varnumber[scount]]++;
				}
				else 
				{
					fprintf(datafile," ; ");
				}
			}
			if(vartype[scount] == 2)
			{
				if(varlength[scount]>count) 
				{
					if(*ivec[varnumber[scount]] == missing_ob) fprintf(datafile,"  ;  ");
					else
					{
						fprintf(datafile,"%i ", *ivec[varnumber[scount]]);
						if(bigy < *ivec[varnumber[scount]] && scount != numbvars) bigy = *ivec[varnumber[scount]];
						if(smally > *ivec[varnumber[scount]] && scount != numbvars) smally = *ivec[varnumber[scount]];
						if(bigx < *ivec[varnumber[scount]] && scount == numbvars) bigx = *ivec[varnumber[scount]];
						if(smallx > *ivec[varnumber[scount]] && scount == numbvars) smallx = *ivec[varnumber[scount]];
					}
					ivec[varnumber[scount]]++;
				}
				else 
				{
					fprintf(datafile," ; ");
				}
			}
		}
	fprintf(datafile,"\n");
	}
	fclose(datafile);
	commandfile = fopen("/tmp/gnucoms", "w");
	fprintf(commandfile,"set term dumb %d %d\n", COLS - 1, LINES - 1);
	fprintf(commandfile,"set tics out\n");
	if(key == 0) fprintf(commandfile,"set nokey\n");
	if(key == 2) fprintf(commandfile,"set offset 0,%f,0,0\n", ((bigy-smally) * keyscale));
	if(key == 3) fprintf(commandfile,"set key %f,%f\n", (bigx + (keyscale * (bigx - smallx))), bigy);
	if(strlen(xrange) > 0) fprintf(commandfile,"set xrange %s \n",xrange);
	if(strlen(yrange) > 0) fprintf(commandfile,"set yrange %s \n",yrange);
	if(strlen(xtics) > 0) fprintf(commandfile,"set xtics %s \n",xtics);
	if(strlen(ytics) > 0) fprintf(commandfile,"set ytics %s \n",ytics);
	if(grid == TRUE) fprintf(commandfile,"set grid \n");
	if(strlen(graphtitle) > 0) 
	{
		strcpy(graphtitle,add_blanks(graphtitle));
		fprintf(commandfile,"set title \"%s\"\n", graphtitle);
	}
	if(strlen(xtitle) > 0) 
	{
		strcpy(xtitle,add_blanks(xtitle));
		fprintf(commandfile,"set xlabel \"%s\"\n", xtitle);
	}
	if(strlen(ytitle) > 0) 
	{
		strcpy(ytitle,add_blanks(ytitle));
		fprintf(commandfile,"set ylabel \"%s\"\n", ytitle);
	}
	fprintf(commandfile,"plot ");
	for(scount = numbvars; scount > 1; scount --)
	{
		fprintf(commandfile,"\"/tmp/lddata\" using 1 : %i ", scount);
		fprintf(commandfile," title \"%s\" ", vname[numbvars - scount + 1]);
		if(line[numbvars - scount + 1] == 0 && point[numbvars - scount + 1] == 0)
		{
			fprintf(commandfile," with dots ");
		}
		if(line[numbvars - scount + 1] == 0 && point[numbvars - scount + 1] != 0)
		{
			fprintf(commandfile," with points 1 %i ", point[numbvars - scount + 1]);
		}
		if(line[numbvars - scount + 1] != 0 && point[numbvars - scount + 1] == 0)
		{
			fprintf(commandfile," with lines %i ", line[numbvars - scount + 1]);
		}
		if(line[numbvars - scount + 1] != 0 && point[numbvars - scount + 1] != 0)
		{
			fprintf(commandfile," with linespoints %i %i ", line[numbvars - scount + 1], point[numbvars - scount + 1]);
		}
		if(scount > 2 && numbvars > 1) fprintf(commandfile,", ");
	}
	fprintf(commandfile,"\n");
	if(strlen(savename) > 0)
	{
		fprintf(commandfile,"set term %s\n", graphform);
		fprintf(commandfile,"set output \"%s\" \n", savename);
		fprintf(commandfile,"replot\n");
	}
	fclose(commandfile);
	pipe(p);
	switch (pid = fork())
	{
		case 0 :	close(WRITE); dup(p[WRITE]); close(p[WRITE]);
				execl("/usr/bin/gnuplot", "gnuplot", "/tmp/gnucoms", 0);
				alert(error(32),alert_time);  
				return;
				
		case -1:	alert(error(33),alert_time);
				return;
				
		default:	fp = fdopen(p[READ],"r");
				close(p[WRITE]);
	}
	saystatus("Plot Preview       ");
	graphbox=newwin(LINES-1,COLS,0,0);
	touchwin(graphbox);
	wrefresh(graphbox);
	while(!feof(fp))
	{
		herb = fgetc(fp);
		if((herb > 31 && herb < 126) || herb == '\n') wprintw(graphbox,"%c", herb);
	}
	wrefresh(graphbox);
	ldwait();
	wait(0);
	fclose(fp);
	close(p[READ]);
	wclear(graphbox);
	wrefresh(graphbox);
	delwin(graphbox);
	refresh();
	system("rm /tmp/lddata");
	system("rm /tmp/gnucoms"); 
}

float ripaconst(int place, int cycle)
{
	int count;
	int escapeloop;
	float cissostupid;
	char theconst[MAX_INPUT];
	count = 0;
	escapeloop = FALSE;
	strcpy(theconst,"\0");
	while(escapeloop == FALSE)
	{
		if(coinput[place+count] == '\n' 
		|| coinput[place+count] == '\0' 
		|| coinput[place+count] == '*'
		|| coinput[place+count] == '/'
		|| coinput[place+count] == '+'
		|| coinput[place+count] == '-'
		|| coinput[place+count] == ')'
		|| coinput[place+count] == '^'
		|| coinput[place+count] == ' '
		)
		{
			theconst[count] = '\0';
			escapeloop = TRUE;
		}
		else
		{
			theconst[count] = coinput[place + count];
			count++;
		}
	}
	if(strcmp(theconst,"_n") == 0)
	{
		cissostupid = cycle + 1;
		return(cissostupid);
	}
	for(count = 0; count < MAX_CONS; count++)
	{
		if(strcmp(constants[count].c_name,theconst) == 0 && strlen(constants[count].c_name) > 1)
		{
			return(constants[count].c_value);
		}
	}
	alert(error(42), alert_time);
}

float howlong(int place,int cycle)
{
	int count, countt;
	int escapeloop;
	char theconst[MAX_INPUT];
	count = 0;
	escapeloop = FALSE;
	strcpy(theconst,"\0");
	while(escapeloop == FALSE)
	{
		if(coinput[place+count] == '\n' 
		|| coinput[place+count] == '\0' 
		|| coinput[place+count] == '*'
		|| coinput[place+count] == '/'
		|| coinput[place+count] == '+'
		|| coinput[place+count] == '-'
		|| coinput[place+count] == ')'
		|| coinput[place+count] == '^'
		|| coinput[place+count] == ' '
		)
		{
			theconst[count] = '\0';
			escapeloop = TRUE;
		}
		else
		{
			theconst[count] = coinput[place + count];
			count++;
		}
	}
	if(strcmp(theconst,"_n") == 0)
	{
		return(count - 1);
	}
	for(countt = 0; countt < MAX_CONS; countt++)
	{
		if(strcmp(constants[countt].c_name,theconst) == 0)
		{
			return(count - 1 );
		}
	}
	return(-1);
}

float silentcalc (char coinput[MAX_INPUT], int cycle)
{
	FILE *fdopen(), *fp, *writeto, *anyerrors;
	int pid, count, adjust;
	int p[2], q[2], e[2];
	float result;
	char frombc[MAX_INPUT];
	pipe(p);
	pipe(q);
	pipe(e);
	strcpy(frombc,"\0");
	switch (pid = fork())
	{
		case 0 :	close(WRITE); dup(p[WRITE]); close(p[WRITE]);
				close(READ); dup(q[READ]); close(q[READ]);
				close(ERROR); dup(e[WRITE]); close(e[WRITE]);
				close(p[READ]);
				close(q[WRITE]);
				close(e[READ]);
				execlp("/usr/bin/bc", "bc", "-l", 0);
				alert(error(32),alert_time);  
				return;
				
		case -1:	alert(error(33),alert_time);
				return;
				
		default:	fp = fdopen(p[READ],"r");
				writeto = fdopen(q[WRITE],"w");
				anyerrors = fdopen(e[READ],"r");
				close(p[WRITE]);
				close(q[READ]);
				close(e[WRITE]);
	}
	for(count = 0; count < strlen(coinput); count++)
	{
		if(coinput[count] == 'l' && coinput[count + 1] == 'o' && coinput[count + 2] == 'g' && coinput[count + 3] == '(')
		{
			coinput[count]     = ' ';
			coinput[count + 1] = ' ';
			coinput[count + 2] = 'l';
		}
		if(coinput[count] == 'e' && coinput[count + 1] == 'x' && coinput[count + 2] == 'p'&& coinput[count + 3] == '(')
		{
			coinput[count]     = ' ';
			coinput[count + 1] = ' ';
			coinput[count + 2] = 'e';
		}
	}
	for(count = 0; count < strlen(coinput); count++)
	{
		if(coinput[count] == '_')
		{
			adjust = howlong(count,cycle);
			if(adjust < 0)
			{
				alert(error(71), alert_time);
				fclose(writeto);
				close(q[WRITE]);
				wait(0);
				fclose(fp);
				close(p[READ]);
				fclose(anyerrors);
				close(q[READ]);
				close(e[READ]);
				return(missing_ob);
			}
			fprintf(writeto,"%f",ripaconst(count,cycle));
			count = count + adjust;
		}
		else
		{
			fprintf(writeto,"%c", coinput[count]);
		}
	}
	fprintf(writeto,"\n");
	fclose(writeto);
	close(q[WRITE]);
	fscanf(anyerrors,"%s",&frombc);
	if(strlen(frombc) > 0) 
	{
		alert(error(71), alert_time);
		return(missing_ob);
	}
	fscanf(fp,"%f", &result);
	wait(0);
	fclose(fp);
	close(p[READ]);
	fclose(anyerrors);
	close(e[READ]);
	close(q[READ]);
	return(result);
}


float ripavar(int place, int cycle)
{
	int count, countt, index, counts, tokenindex;
	int escapeloop;
	float cissostupid;
	char theconst[MAX_INPUT], token[MAX_INPUT], temp[MAX_INPUT];
	count = 0;
	escapeloop = FALSE;
	index = cycle;
	strcpy(theconst,"\0");
	if(coinput[place] =='r' 
	&& coinput[place+1] =='a'
	&& coinput[place+2] =='n'
	&& coinput[place+3] =='d'
	&& coinput[place+4] =='('
	&& coinput[place+5] ==')'
	)
	{
		cissostupid = rand() % 100;
		cissostupid = cissostupid / 100;
		return(cissostupid);
	}
	while(escapeloop == FALSE)
	{
		if(coinput[place+count] == '\n' 
		|| coinput[place+count] == '\0' 
		|| coinput[place+count] == '*'
		|| coinput[place+count] == '/'
		|| coinput[place+count] == '+'
		|| coinput[place+count] == '-'
		|| coinput[place+count] == ')'
		|| coinput[place+count] == '^'
		|| coinput[place+count] == ' '
		|| coinput[place+count] == '['
		)
		{
			theconst[count] = '\0';
			escapeloop = TRUE;
		}
		else
		{
			theconst[count] = coinput[place + count];
			count++;
		}
	}
	if(coinput[place+count] == '[')
	{
		escapeloop = FALSE;
		counts = place+count+1;
		strcpy(token,"\0");
		index = 0;
		tokenindex = 0;
		while(escapeloop == FALSE)
		{
			if(coinput[counts] == ']')
			{
				token[tokenindex] ='\0';
				escapeloop = TRUE;
			}
			else
			{
				token[tokenindex] = coinput[counts];
				tokenindex++;
				counts++;
			}
		}
		strcpy(temp, coinput);
		strcpy(coinput, token);
		index = silentcalc(coinput,cycle) - 1;
		strcpy(coinput,temp);
		if(index + 1 == missing_ob)
		{
			screwup = TRUE;
			return(0);
		}
	}
	for(countt = 0; countt < MAX_VARS; countt++)
	{
		if(strcmp(d_matrix[countt].v_name,theconst) == 0)
		{
			if(d_matrix[countt].fnumb != -1)
			{
				fvec[d_matrix[countt].fnumb] = d_matrix[countt].fmem_start;
				if(index < 0 || index >= d_matrix[countt].nobs)
				{
					working[cycle] = missing_ob;
					return(missing_ob);
				}
				if(*(fvec[d_matrix[countt].fnumb] + index) == missing_ob) working[cycle] = missing_ob;
				return(*(fvec[d_matrix[countt].fnumb] + index));
			}
			if(d_matrix[countt].inumb != -1)
			{
				ivec[d_matrix[countt].inumb] = d_matrix[countt].imem_start;
				if(index < 0 || index >= d_matrix[countt].nobs)
				{
					working[cycle] = missing_ob;
					return(missing_ob);
				}
				if(*(ivec[d_matrix[countt].inumb] + index) == missing_ob) working[cycle] = missing_ob;
				return(*(ivec[d_matrix[countt].inumb] + index));
			}
			if(index < 0 || index >= d_matrix[countt].nobs)
			{
				working[cycle] = missing_ob;
				return(missing_ob);
			}
			if(atof(smatrix[d_matrix[countt].snumb][index]) == missing_ob) working[cycle] = missing_ob;
			return(atof(smatrix[d_matrix[countt].snumb][index]));
		}
	}
	alert(error(42), alert_time);
}


float howlongvar(int place,int cycle)
{
	int count, countt, openbrace;
	int escapeloop;
	char theconst[MAX_INPUT];
	count = 0;
	escapeloop = FALSE;
	openbrace=FALSE;
	if(coinput[place] =='l' && coinput[place+1] =='(')
	{
		return(0);
	}
	if(coinput[place] =='e' && coinput[place+1] =='(')
	{
		return(0);
	}
	if(coinput[place] =='r' 
	&& coinput[place+1] =='a'
	&& coinput[place+2] =='n'
	&& coinput[place+3] =='d'
	&& coinput[place+4] =='('
	&& coinput[place+5] ==')'
	)
	{
		return(5);
	}
	strcpy(theconst,"\0");
	while(escapeloop == FALSE)
	{
		if(coinput[place+count] == '[')
		{
			openbrace = TRUE;
			count++;
		}
		if(coinput[place+count] == ']' && openbrace == TRUE) openbrace = FALSE;
		if(coinput[place+count] == '\n' 
		|| coinput[place+count] == '\0' 
		|| coinput[place+count] == '*'
		|| coinput[place+count] == '/'
		|| coinput[place+count] == '+'
		|| coinput[place+count] == '-'
		|| coinput[place+count] == ')'
		|| coinput[place+count] == '^'
		|| coinput[place+count] == ' '
		|| coinput[place+count] == ']'
		)
		{
			if(openbrace==FALSE)
			{
				theconst[count] = '\0';
				if(coinput[place+count] == ']') count++;
				escapeloop = TRUE;
			}
			if(openbrace==TRUE)
			{
				count++;
			}
		}
		else
		{
			theconst[count] = coinput[place + count];
			count++;
		}
	}
	if(strcmp(theconst,"_n") == 0)
	{
		return(count - 1);
	}
	for(countt = 0; countt < MAX_VARS; countt++)
	{
		if(strcmp(d_matrix[countt].v_name,theconst) == 0)
		{
			return(count - 1 );
		}
	}
	return(-1);
}
	

void ldcalc (char coinput[MAX_INPUT])
{
	FILE *fdopen(), *fp, *writeto, *anyerrors;
	int pid, count, adjust;
	int p[2], q[2], e[2];
	float result;
	char frombc[MAX_INPUT];
	pipe(p);
	pipe(q);
	pipe(e);
	strcpy(frombc,"\0");
	saystatus("Calculating...     ");
	switch (pid = fork())
	{
		case 0 :	close(WRITE); dup(p[WRITE]); close(p[WRITE]);
				close(READ); dup(q[READ]); close(q[READ]);
				close(ERROR); dup(e[WRITE]); close(e[WRITE]);
				close(p[READ]);
				close(q[WRITE]);
				close(e[READ]);
				execlp("/usr/bin/bc", "bc", "-l", 0);
				alert(error(32),alert_time);  
				return;
				
		case -1:	alert(error(33),alert_time);
				return;
				
		default:	fp = fdopen(p[READ],"r");
				writeto = fdopen(q[WRITE],"w");
				anyerrors = fdopen(e[READ],"r");
				close(p[WRITE]);
				close(q[READ]);
				close(e[WRITE]);
	}
	for(count = 0; count < strlen(coinput); count++)
	{
		if(coinput[count] == 'l' && coinput[count + 1] == 'o' && coinput[count + 2] == 'g' && coinput[count + 3] == '(')
		{
			coinput[count]     = ' ';
			coinput[count + 1] = ' ';
			coinput[count + 2] = 'l';
		}
		if(coinput[count] == 'e' && coinput[count + 1] == 'x' && coinput[count + 2] == 'p'&& coinput[count + 3] == '(')
		{
			coinput[count]     = ' ';
			coinput[count + 1] = ' ';
			coinput[count + 2] = 'e';
		}
	}
	for(count = 0; count < strlen(coinput); count++)
	{
		if(coinput[count] == '_')
		{
			adjust = howlong(count,0);
			if(adjust < 0)
			{
				alert(error(49), alert_time);
				fclose(writeto);
				close(q[WRITE]);
				wait(0);
				fclose(fp);
				close(p[READ]);
				fclose(anyerrors);
				close(q[READ]);
				close(e[READ]);
				return;
			}
			fprintf(writeto,"%f",ripaconst(count,0));
			count = count + adjust;
		}
		else
		{
			fprintf(writeto,"%c", coinput[count]);
		}
	}
	fprintf(writeto,"\n");
	fclose(writeto);
	close(q[WRITE]);
	fscanf(anyerrors,"%s",&frombc);
	if(strlen(frombc) > 0) alert(error(68), alert_time);
	fscanf(fp,"%f", &result);
	wprintw(ioarea,"\nResult is %f", result);
	wrefresh(ioarea);
	wait(0);
	fclose(fp);
	close(p[READ]);
	fclose(anyerrors);
	close(e[READ]);
	close(q[READ]);
}

void ldgen (char coinput[MAX_INPUT])
{
	FILE *tobc, *frombc;
	int count, countt, adjust, outer, skip, escapeloop, marker;
	int vnum,f_numb, bigobs;
	float result;
	char token[MAX_INPUT], tokent[MAX_INPUT], lower[MAX_INPUT], upper[MAX_INPUT];
	saystatus("Generating...      ");
	strcpy(token,puller(coinput));
	strcat(coinput, " \0");
	if(token[0] < 65 || token[0] > 122)
	{
		alert(error(53), alert_time);
		return;
	}
	if(token[0] > 90 && token[0] < 97)
	{
		alert(error(53), alert_time);
		return;
	}
	if(checkname(token) < 0)
	{
		alert(error(14),alert_time);
		return;
	}
	vnum = findempty();
	if(vnum < 0)
	{
		alert(error(3),alert_time);
		return;
	}
	strcpy(tokent,puller(coinput));
	if(strlen(tokent) < 1)
	{
		alert(error(69), alert_time);
		return;
	}
	if(strncmp(tokent,"=",1) != 0)
	{
		strcat(tokent,coinput);
		strcpy(coinput, tokent);
	}
	f_numb = typeaug(1,vnum);
	fvec[f_numb] = (double *) malloc (MAX_OBS * sizeof(double));
	if (!fvec[f_numb])
	{
		alert(error(4),alert_time);
		return;
	}
	strcpy(d_matrix[vnum].v_name,token);
	d_matrix[vnum].fnumb = f_numb;
	d_matrix[vnum].fmem_start=fvec[f_numb];
	bigobs = 0;
	astart = 1;
	for(count = 0; count < MAX_OBS; count++)
	{
		working[count]=0;
	}
	for(count = 0; count < MAX_VARS; count++)
	{
		if(d_matrix[count].fnumb != -1) fvec[d_matrix[count].fnumb] = d_matrix[count].fmem_start;
		if(d_matrix[count].inumb != -1) ivec[d_matrix[count].inumb] = d_matrix[count].imem_start;
		if (bigobs < d_matrix[count].nobs) bigobs = d_matrix[count].nobs;
	}
	astop = bigobs;
	for(count = 0; count < strlen(coinput); count++)
	{
		if(coinput[count] == 'l' && coinput[count + 1] == 'o' && coinput[count + 2] == 'g' && coinput[count + 3] == '(')
		{
			coinput[count]     = ' ';
			coinput[count + 1] = ' ';
			coinput[count + 2] = 'l';
		}
		if(coinput[count] == 'e' && coinput[count + 1] == 'x' && coinput[count + 2] == 'p'&& coinput[count + 3] == '(')
		{
			coinput[count]     = ' ';
			coinput[count + 1] = ' ';
			coinput[count + 2] = 'e';
		}
	}
	for(count = 0; count < strlen(coinput); count++)
	{
		if(coinput[count] == ' ' 
		&& coinput[count + 1] == 'i'
		&& coinput[count + 2] == 'n'
		&& coinput[count + 3] == ' '
		)
		{
			strcpy(lower,"\0");
			strcpy(upper,"\0");
			countt = count + 4;
			escapeloop = FALSE;
			while(escapeloop == FALSE)
			{
				if(coinput[countt] == ' ') countt++;
				else escapeloop = TRUE;
			}
			escapeloop = FALSE;
			marker = 0;
			while(escapeloop == FALSE)
			{
				if(coinput[countt] != ' ') 
				{
					lower[marker]=coinput[countt];
					marker++;
					countt++;
				}
				else escapeloop = TRUE;
			}
			lower[marker+1] ='\0';
			escapeloop = FALSE;
			while(escapeloop == FALSE)
			{
				if(coinput[countt] == ' ') countt++;
				else escapeloop = TRUE;
			}
			escapeloop = FALSE;
			marker = 0;
			while(escapeloop == FALSE)
			{
				if(coinput[countt] != ' ') 
				{
					upper[marker]=coinput[countt];
					marker++;
					countt++;
				}
				else escapeloop = TRUE;
			}
			upper[marker+1] = '\0';
			astart = atoi(lower);
			astop = atoi(upper);
			if(astop > MAX_OBS) astop = MAX_OBS;
			if(astart < 1) astart = 1;
			if(astop < 1 || astart > astop)
			{
				alert(error(27), alert_time);
				return;
			}
			for(outer = count + 1; outer <= countt; outer++)
			{
				coinput[outer] = ' ';
			}
		}			
	}
	tobc = fopen("/tmp/ldtemp1", "w");
	for(outer = astart - 1; outer < astop; outer++)
	{
		for(count = 0; count < strlen(coinput); count++)
		{
			skip = FALSE;
			if(coinput[count] == '_')
			{
				skip = TRUE;
				adjust = howlong(count, outer);
				if(adjust < 0)
				{
					alert(error(70), alert_time);
					fclose(tobc);
					d_matrix[vnum].nobs = 0;
					strcpy(d_matrix[vnum].v_name,"\0");
					flushempty();
					return;
				}
				fprintf(tobc,"%f",ripaconst(count,outer));
				count = count + adjust;
			}
			else
			{
				if(coinput[count] > 64 && coinput[count] < 91)
				{
					skip = TRUE;
					adjust = howlongvar(count, outer);
					if(adjust < 0)
					{
						alert(error(2), alert_time);
						fclose(tobc);
						d_matrix[vnum].nobs = 0;
						strcpy(d_matrix[vnum].v_name,"\0");
						flushempty();
						return;
					}
					if(adjust == 0) skip = FALSE;
					else
					{
						screwup=FALSE;
						result = ripavar(count,outer);
						if(screwup==TRUE)
						{
							alert(error(2), alert_time);
							fclose(tobc);
							d_matrix[vnum].nobs = 0;
							strcpy(d_matrix[vnum].v_name,"\0");
							flushempty();
							return;
						}
						fprintf(tobc,"%f",result);
						count = count + adjust;
					}
				}
				if(coinput[count] > 96 && coinput[count] < 123)
				{
					skip = TRUE;
					adjust = howlongvar(count, outer);
					if(adjust < 0)
					{
						alert(error(49), alert_time);
						fclose(tobc);
						d_matrix[vnum].nobs = 0;
						strcpy(d_matrix[vnum].v_name,"\0");
						return;
					}
					if(adjust == 0) skip = FALSE;
					else
					{
						screwup=FALSE;
						result = ripavar(count,outer);
						if(screwup==TRUE)
						{
							alert(error(2), alert_time);
							fclose(tobc);
							d_matrix[vnum].nobs = 0;
							strcpy(d_matrix[vnum].v_name,"\0");
							flushempty();
							return;
						}
						fprintf(tobc,"%f",result);
						count = count + adjust;
					}
				}
			}
			if(skip == FALSE)
			{
				fprintf(tobc,"%c", coinput[count]);
			}
		}
	        fprintf(tobc,"\n");
	}
	fclose(tobc);
	close(ERROR);
	system("bc -l < /tmp/ldtemp1 > /tmp/ldtemp2");
	wait(0);
	open(ERROR);
	marker=0;
	for(count = 0; count < astart - 1; count++)
	{
		*(fvec[f_numb] + marker) = missing_ob;
		marker++;
	}
	frombc = fopen("/tmp/ldtemp2","r");
	while(!feof(frombc))
	{
		fscanf(frombc,"%f\n", &result);
		*(fvec[f_numb] + marker) = result;
		marker++;
	}
	fclose(frombc);
	d_matrix[vnum].nobs = astop; 
	if(marker != astop)
	{
		alert(error(70), alert_time);
		d_matrix[vnum].nobs = 0;
		strcpy(d_matrix[vnum].v_name,"\0");
	}
	system("rm /tmp/ldtemp1");
	system("rm /tmp/ldtemp2");
	for(count = 0; count < astop;count++)
	{
		if(working[count] ==missing_ob) *(fvec[f_numb] + count) = missing_ob;
	}
	oktoquit=FALSE;
}

void ldreplace(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT], tokent[MAX_INPUT];
	int count, match, vnumb, vnumbtwo;
	strcpy(token,puller(coinput));
	if(strlen(token) < 1)
	{
		alert(error(72), alert_time);
		return;
	}
	match=FALSE;
	for(count = 0; count < MAX_VARS; count++)
	{
		if(strcmp(d_matrix[count].v_name,token)==0)
		{
			match=TRUE;
			vnumb = count;
			if(d_matrix[count].snumb != -1)
			{
				alert(error(73), alert_time);
				return;
			}
			astart = 1;
			astop = d_matrix[count].nobs;
			count = MAX_VARS;
		}
	}
	if(match == FALSE)
	{
		alert(error(72), alert_time);
		return;
	}
	strcpy(tokent,"kitschchewing\0");
	strcat(tokent,coinput);
	strcpy(coinput,tokent);
	ldgen(coinput);
	strcpy(tokent,"kitschchewing\0");
	match=FALSE;
	for(count = 0; count < MAX_VARS; count++)
	{
		if(strcmp(d_matrix[count].v_name,tokent)==0)
		{
			match=TRUE;
			vnumbtwo = count;
			count = MAX_VARS;
		}
	}
	if(match == FALSE) return;
	if(d_matrix[vnumb].fnumb != -1)
	{
		for(count = astart - 1; count < astop; count++)
		{
			*(fvec[d_matrix[vnumb].fnumb] + count) = *(fvec[d_matrix[vnumbtwo].fnumb] + count);
		}
		strcpy(d_matrix[vnumbtwo].v_name,"\0");
		d_matrix[vnumbtwo].nobs = 0;
		flushempty();
		return;
	}
	if(d_matrix[vnumb].inumb != -1)
	{
		for(count = astart - 1; count < astop; count++)
		{
			*(ivec[d_matrix[vnumb].inumb] + count) = *(fvec[d_matrix[vnumbtwo].fnumb] + count);
		}
		strcpy(d_matrix[vnumbtwo].v_name,"\0");
		d_matrix[vnumbtwo].nobs = 0;
		flushempty();
		return;
	}
	alert(error(42), alert_time);
}