/*      manip.h  

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file sets up functions for manipualting
	strings (ie. commands):
	
		puller()	Returns the first word from a string
				and the string comes back with that
				word pulled off.

	
*/

#define EMPTY_STR   ""
#define BLANK_CHAR  ' '
#define NULL_CHAR   '\0'

int char_pos (char str [], int ch)
{
	int index;
	for (index = 0; ( str [index] != ch) &&
	                ( str [index] != NULL_CHAR) ; index++)
	       ;
	if (str [index] == NULL_CHAR)
		return (-1);
	else
		return (index);
}

void delete (char *str, int start, int how_many)
{
	int index1, index2;
	if (start < 0)
		start = 0;
	if (start + how_many - 1 > strlen (str))
		how_many = strlen (str) + 1 - start;
	for(index1 = start, index2 = start + how_many;
		str [index2] != NULL_CHAR; index1++, index2 ++)
		{
			str [index1] = str [index2];
		}
	str[index1] = NULL_CHAR;
}

char * puller (char *str) 
{
	int index, where;
	char temp [MAX_INPUT];
	while (!char_pos (str, BLANK_CHAR))
		delete (str, 0, 1);
	where = char_pos (str, BLANK_CHAR) ;
	if (where >= 0)
	{
		for (index = 0; index < where; index ++)
			temp [index] = str [index];
		temp [index] = NULL_CHAR;
		delete (str, 0, where);
	}
	else
	{
		strcpy (temp,str);
		str [0] = NULL_CHAR;
	}
	return (temp);
}	

char * pullone (char *str) 
{
	int index, where;
	char temp [MAX_INPUT];
	strcpy(temp,str);
	for(index = 0; index <= strlen(str); index++)
	{
		temp[index] = temp[index + 1];
	}
	temp[strlen(str)] = '\0';
	return(temp);
}	

void saystatus(char *status)
{
	mvwaddstr(statusbar,0,COLS-20,status);
	touchwin(statusbar);
	touchwin(ioarea);
	wrefresh(statusbar);
	wrefresh(ioarea);
}

void loutput(char output[MAX_INPUT])
{
	echo();
	waddstr(ioarea,output);
	wrefresh(ioarea);
/*	touchwin(statusbar);
	wrefresh(statusbar); */
	noecho();
}

void backforthoutput(	char output[MAX_INPUT], 
			int startx, 
			int starty, 
			int curx,
			int cury,
			int length,
			int place,
			int lines)
{
	int count, scount, placey, placex;
	wmove(ioarea,starty,startx);
	for(count = 0; count < COLS - 7; count ++)
	{
		waddch(ioarea,' ');
	}
	for(count = 1; count < lines; count ++)
	{
		for(scount = 0; scount < COLS - 1; scount ++)
		{
			waddch(ioarea,' ');
		}
	}
	wmove(ioarea,starty,startx);
	waddstr(ioarea,output);
	wmove(ioarea,starty + ((place + 6)/ COLS),(curx % COLS));
	wrefresh(ioarea);
	noecho();
}

void get_input(char coinput[MAX_INPUT])
{
	int cinput,length,place,startx,starty,curx,cury,count,histref,sloop,lines;
	int escape = 0;
	place = 0;
	length = 0;
	histref = 0;
	saystatus("Command Input Mode");
	getyx(ioarea,starty,startx);
	curx=startx;
	cury=starty;
	lines = 1;
	coinput[0]='\0';
	while(escape == 0)
	{
		cinput=wgetch(ioarea);
		if(cinput == KEY_BACKSPACE && startx != curx)
		{
			for(count = place - 1; count < length + 1; count++)
			{
				coinput[count]=coinput[count + 1];
			}
			mvwdelch(ioarea,cury,(startx + length - 1) % COLS);
			place--;
			length--;
		}
		if(cinput == KEY_DC && place != length)
		{
			for(count = place; count < length + 1; count++)
			{
				coinput[count]=coinput[count + 1];
			}
			mvwdelch(ioarea,cury,(startx + length - 1) % COLS);
			length--;
		}
		if(cinput == KEY_UP && histref != MAX_HISTORY)
		{
			mvwdelch(ioarea,starty,startx);
			for(count = 0; count < length; count ++)
			{
				wdelch(ioarea);
			}
			if(histref == 0) strcpy(cohistory[MAX_HISTORY-1],coinput);
			histref++;
			strcpy(coinput,cohistory[MAX_HISTORY - 1 - histref]);
			length=strlen(coinput);
			place=length;
		}
		if(cinput == KEY_DOWN && histref != 0)
		{
			mvwdelch(ioarea,starty,startx);
			for(count = 0; count < length; count ++)
			{
				wdelch(ioarea);
			}
			histref --;
			strcpy(coinput,cohistory[MAX_HISTORY - 1 - histref]);
			length=strlen(coinput);
			place=length;
		}
		if(cinput == KEY_LEFT) place--;
		if(cinput == KEY_END) place = length;
		if(cinput == KEY_RIGHT) place++;
		if(place < 0) place = 0;
		if(length < 0) length = 0;
		if(place == length + 1) place --;
		if(cinput == KEY_IC) cinput = 32;
		if(cinput > 31 && cinput < 126)
		{
			length++;
			if(length > MAX_INPUT) length = MAX_INPUT; 
			for(count = length; count > place - 1; count --)
			{
				coinput[count + 1]=coinput[count];
			}
			coinput[place] = cinput;
			place++;
		}
		coinput[length]='\0';
		curx=startx+place;
/*              
                Below are the nasty complications introduced by having
                input scroll onto multiple lines
                
*/
		for(sloop = 0; sloop <= (MAX_INPUT/COLS) + 1;sloop++)
		{
			if(lines < ((length + 6) / (COLS)) + 1)
			{
				scroll(ioarea);
				wrefresh(ioarea);
				lines++;
				starty--;
				curx=0;
			}
		}		
		backforthoutput(coinput,startx,starty,curx,cury,length,place,lines);
		if(cinput == '\n') escape = 1;
	}
	place = length;
	curx=startx+place;
	backforthoutput(coinput,startx,starty,curx,cury,length,place,lines);
	if(length > 1)
	{
		for(count = 0; count < MAX_HISTORY - 2; count ++)
		{
			strcpy(cohistory[count],cohistory[count+1]);
		}
		strcpy(cohistory[MAX_HISTORY - 2], coinput);
		cohistory[MAX_HISTORY - 1][0]='\0';
	}
}

int parse_input (char coinput[MAX_INPUT])
{
	if (strncmp(coinput,"\0",strlen(coinput))  == 0) return 9;
	if (strncmp(coinput,"help",strlen(coinput)) == 0) return 2;
	if (strncmp(coinput,"exit",strlen(coinput)) == 0) return 1;
	if (strncmp(coinput,"bye",strlen(coinput)) == 0) return 1;
	if (strncmp(coinput,"quit",strlen(coinput)) == 0) return 1;
	if (strncmp(coinput,"refresh",strlen(coinput)) == 0) return 3;
	if (strncmp(coinput,"warranty", strlen(coinput)) == 0) return 4;
	if (strncmp(coinput,"why", strlen(coinput)) == 0) return 5;
	if (strncmp(coinput,"about", strlen(coinput)) == 0) return 6;
	if (strncmp(coinput,"in",strlen(coinput))  == 0) return 31;
	if (strncmp(coinput,"input", strlen(coinput)) == 0) return 7;
	if (strncmp(coinput,"list", strlen(coinput)) == 0) return 8;
	if (strncmp(coinput,"describe", strlen(coinput)) == 0) return 10;
	if (strncmp(coinput,"showstate", strlen(coinput)) == 0) return 11;
	if (strncmp(coinput,"drop", strlen(coinput)) == 0) return 12;
	if (strncmp(coinput,"label", strlen(coinput)) == 0) return 13;
	if (strncmp(coinput,"save", strlen(coinput)) == 0) return 14;
	if (strncmp(coinput,"load", strlen(coinput)) == 0) return 15;
	if (strncmp(coinput,"finput", strlen(coinput)) == 0) return 16;
	if (strncmp(coinput,"summarize", strlen(coinput)) == 0) return 17;
	if (strncmp(coinput,"time", strlen(coinput)) == 0) return 18;
	if (strncmp(coinput,"set", strlen(coinput)) == 0) return 19;
        if (strncmp(coinput,"quote", strlen(coinput)) == 0) return 20;
        if (strncmp(coinput,"log", strlen(coinput)) == 0) return 21;
        if (strncmp(coinput,"texlog", strlen(coinput)) == 0) return 22;
	if (strncmp(coinput,"wait", strlen(coinput)) == 0) return 23;
	if (strncmp(coinput,"echo", strlen(coinput)) == 0) return 25;
	if (strncmp(coinput,"tutorial", strlen(coinput)) == 0) return 26;
	if (strncmp(coinput,"interpolate", strlen(coinput)) == 0) return 27;
	if (strncmp(coinput,"more", strlen(coinput)) == 0) return 28;
	if (strncmp(coinput,"missing", strlen(coinput)) == 0) return 29;
	if (strncmp(coinput,"ls", strlen(coinput))  == 0) return 30;
	if (strncmp(coinput,"dir", strlen(coinput)) == 0) return 30;
	if (strncmp(coinput,"do", strlen(coinput))  == 0) return 32;
	if (strncmp(coinput,"fappend", strlen(coinput)) == 0) return 33;
	if (strncmp(coinput,"histogram", strlen(coinput)) == 0) return 34;
	if (strncmp(coinput,"replace", strlen(coinput)) == 0) return 35;
	if (strncmp(coinput,"append", strlen(coinput)) == 0) return 36;
/*	if (strncmp(coinput,"nnp", strlen(coinput)) == 0) return 37;
	if (strncmp(coinput,"info", strlen(coinput)) == 0) return 38;*/
	if (strncmp(coinput,"regress", strlen(coinput)) == 0) return 39;
/*	if (strncmp(coinput,"extrapolate", strlen(coinput)) == 0) return 40;*/
	if (strncmp(coinput,"generate", strlen(coinput)) == 0) return 41;
	if (strncmp(coinput,"predict", strlen(coinput)) == 0) return 42;
	if (strncmp(coinput,"rename", strlen(coinput)) == 0) return 43;
	if (strncmp(coinput,"graph", strlen(coinput)) == 0) return 47;
	if (strncmp(coinput,"let", strlen(coinput)) == 0) return 48;
	if (strncmp(coinput,"calculate", strlen(coinput)) == 0) return 49;
	else return 99;
}

