/*      regress.h  
 
	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file includes routines to do regressions and tests.
	
*/

/*void nnpredict(char coinput[MAX_INPUT])
{
	wprintw(ioarea,"\n NYF: nnpredict");
	wrefresh(ioarea);
}

float gamma_function (float ivalue, float cvalue)
{
	float answer;
	answer = exp(-1 * ivalue) * pow(ivalue, cvalue - 1);
	return(answer);
}

float gamma_integral (float cvalue)
{
	int count;
	float lower, upper, width, precision, answer;
	answer = 0;
	lower = 0;
	upper = cvalue * 10;
	precision = INT_PREC;
	width = (upper - lower) / precision;
	for(count = 1; count < precision; count++)
	{
		answer = answer + width * (gamma_function(lower + (count - 1) * width, cvalue) + 4 * gamma_function(lower - (width / 2) + count * width, cvalue) + gamma_function(lower + count * width, cvalue)) / 6;
	}
	return(answer);
}

float t_function (float t_value, float degreef)
{
	float answer;
	answer = (gamma_integral((degreef + 1)/2) * pow(1+((pow(t_value,2)) / degreef), -1 * ((degreef + 1) / 2))) / (sqrt(3.1415927 * degreef) * gamma_integral(degreef /2));
	return(answer);
}

float t_integral (float t_value, float degreef)
{
	int count;
	float lower, upper, width, precision, answer;
	answer = 0;
	lower = -5;
	upper = t_value;
	precision = INT_PREC;
	width = (upper - lower) / precision;
	for(count = 1; count < precision; count++)
	{
		answer = answer + width * (t_function(lower + (count - 1) * width, degreef) + 4 * t_function(lower - (width / 2) + count * width, degreef) + t_function(lower + count * width, degreef)) / 6;
	}
	if(t_value < 0)
	{
		answer = 1 - answer;
	}
	return(answer);
}
*/

void regress(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT];
	char depvar[MAX_INPUT];
	int escape, count, countt, counts, anymissing, temp, more;
	int numbvars;
	int length;
	int variables[MAX_VARS];
	int vartypes[MAX_VARS];
	char varname[MAX_VARS][DESC_LENGTH];
	char tempstring[DESC_LENGTH];
	float coefs[MAX_VARS];
	float fitted[MAX_OBS];
	float ybar, xbar, sst, ssr, scratch, mse;
	double *bigmatrix;
	double *matrix;
	double running;
	int max, column;
	double temp1,temp2;
	escape = FALSE;
	numbvars = 0;
	length = 0;
	theintercept = 0;
	astart = 1;
	for(count = 0; count < MAX_VARS; count++)
	{
		inreglist[count]=FALSE;
		reglist[count]=0;
	}
	strcpy(depvar,puller(coinput));
	strcpy(token,puller(coinput));
	while(escape == FALSE)
	{
		for(count= 0; count < MAX_VARS; count++)
		{
			if(strcmp(d_matrix[count].v_name,token) == 0)
			{
				numbvars++;
				strcpy(varname[numbvars],d_matrix[count].v_name);
				if(d_matrix[count].fnumb != -1) 
				{
					vartypes[numbvars] = 1;
					variables[numbvars] = d_matrix[count].fnumb;
					fvec[variables[numbvars]] = d_matrix[count].fmem_start;
				}
				if(d_matrix[count].inumb != -1)
				{
					vartypes[numbvars] = 2;
					variables[numbvars] = d_matrix[count].inumb;
					ivec[variables[numbvars]] = d_matrix[count].imem_start;
				}
				if(length < d_matrix[count].nobs) length = d_matrix[count].nobs;
				if(d_matrix[count].snumb != -1)
				{
					alert(error(62), alert_time);
					return;
				}
				count = MAX_VARS + 1;
			}
		}
		if(count < MAX_VARS + 1)
		{
			alert(error(63), alert_time);
			return;
		}
		strcpy(token, puller(coinput));
		if(strcmp(token,"in") == 0)
		{
			astart = atoi(puller(coinput));
			astop = atoi(puller(coinput));
			escape = TRUE;
			if(astart < 1) astart = 1;
			if(astop < 1) astop = 1;
			if(astop < astart)
			{
				astop = astart;
				length = 1;
			}
			length = (astop - astart) + 1;
		}
		if(strlen(token) < 1) escape = TRUE;
	}
	for(count= 0; count < MAX_VARS; count++)
	{
		if(strcmp(d_matrix[count].v_name,depvar) == 0)
		{
			numbvars++;
			strcpy(varname[numbvars],d_matrix[count].v_name);
			if(d_matrix[count].fnumb != -1) 
			{
				vartypes[numbvars] = 1;
				variables[numbvars] = d_matrix[count].fnumb;
				fvec[variables[numbvars]] = d_matrix[count].fmem_start;
			}
			if(d_matrix[count].inumb != -1)
			{
				vartypes[numbvars] = 2;
				variables[numbvars] = d_matrix[count].inumb;
				ivec[variables[numbvars]] = d_matrix[count].imem_start;
			}
			if(length < d_matrix[count].nobs) length = d_matrix[count].nobs;
			if(d_matrix[count].snumb != -1)
			{
				alert(error(62), alert_time);
				return;
			}
			count = MAX_VARS + 1;
		}
	}
	if(count < MAX_VARS + 1)
	{
		alert(error(63), alert_time);
		return;
	}
	if(numbvars < 2)
	{
		alert(error(65), alert_time);
		return;
	}
	if(length <= numbvars)
	{
		alert(error(66),alert_time);
		return;
	}
	if(length - numbvars - 1 <= 0)
	{
		alert(error(75),alert_time);
		return;
	}	
	saystatus("Building Matrix... ");
	bigmatrix = (double *) malloc ((length * (numbvars + 1)) * sizeof (double));
	if(!bigmatrix)
	{
		alert(error(64), alert_time);
		return;
	}
	for(count = 0; count < length; count++)
	{
		*(bigmatrix + count) = 1;
	}
	for(count = 1; count <= numbvars; count++)
	{
		for(countt = 0; countt < length; countt++)
		{
			if(vartypes[count] == 1)
			{
				*(bigmatrix + countt + (count * length)) = *(fvec[variables[count]] + (astart - 1));
				fvec[variables[count]]++;
			}
			if(vartypes[count] == 2)
			{
				*(bigmatrix + countt + (count * length)) = *(ivec[variables[count]] + (astart - 1));
				ivec[variables[count]]++;
			}
		}
	}
	saystatus("Zapping Missings...");
	for(count = 0; count < (length * (numbvars + 1)); count ++)
	{
		if(*(bigmatrix + count) == missing_ob)
		{
			column = count % length;
			for(countt = numbvars; countt >= 0; countt--)
			{
				for(counts = (countt * length) + column; counts < (length * (numbvars + 1)) - 1; counts++)
				{
					*(bigmatrix + counts) = *(bigmatrix + counts + 1);
				}
			}
			count = 0;
			length--;
			if(length <= numbvars)
			{
				alert(error(66),alert_time);
				free(bigmatrix);
				return;
			}
		}	
	}
	matrix = (double *) malloc ((numbvars * (numbvars + 1)) * sizeof (double));
	if(!matrix)
	{
		alert(error(64), alert_time);
		return;
	}
	saystatus("Building System... ");
	for(count = 0; count < numbvars; count++)
	{
		for(countt = 0; countt <= numbvars; countt++)
		{
			running = 0;
			for(counts = 0; counts < length; counts++)
			{
				running = running + *(bigmatrix + counts + (count * length)) * *(bigmatrix + counts + (countt * length));
			}
			*(matrix + count + (countt * numbvars)) = running;
		}
	}
	saystatus("Gauss Eliminate... ");
	for(count = 0; count < numbvars; count++)
	{
		max = count;
		for(countt = count + 1; countt < numbvars; countt++)
		{
			temp1 = *(matrix + countt + (count * numbvars));
			temp2 = *(matrix + max + (count * numbvars));
			if(fabs(temp1) > fabs(temp2)) max = countt;
			for(counts = 0; counts <= numbvars; counts++)
			{
				running = *(matrix + count + (counts * numbvars));
				*(matrix + count + (counts * numbvars)) = *(matrix + max + (counts * numbvars));
				*(matrix + max + (counts * numbvars)) = running;
			}
		}
		for(countt = count + 1; countt < numbvars; countt++)
		{
			for(counts = numbvars; counts >= 0; counts--)
			{
				temp1 = *(matrix + count + (count * numbvars));
				if(temp1 == 0)
				{
					alert(error(67), alert_time);
					return;
				}
				*(matrix + countt + (counts * numbvars)) = *(matrix + countt + (counts * numbvars)) - *(matrix + count + (counts * numbvars)) * *(matrix + countt + (count * numbvars)) / *(matrix + count + (count * numbvars));
			}
		}
	}
	saystatus("Substitions...     ");
	for(count = 0; count <= numbvars; count++)
	{
		coefs[count] = 0;
	}
	for(count = numbvars - 1; count >= 0; count--)
	{
		running = 0;
		for(countt = count + 1; countt <= numbvars; countt++)
		{
			running = running + *(matrix + count + (countt * numbvars)) * coefs[countt];
			temp1 = *(matrix + count + (count * numbvars));
			if(temp1 == 0)
			{
				alert(error(67), alert_time);
				return;
			}
			coefs[count]= ( *(matrix + count + (numbvars * numbvars)) - running ) / *(matrix + count + (count * numbvars));
		}
	}
	theintercept = coefs[0];
	for(count = 1; count < numbvars; count ++)
	{
		for(countt = 0; countt < MAX_VARS; countt++)
		{
			if(strcmp(varname[count],d_matrix[countt].v_name) == 0)
			{
				inreglist[countt] = TRUE;
				reglist[countt] = coefs[count];
				countt = MAX_VARS;
			}
		}
	}
	for(count = 0; count < MAX_OBS; count++)
	{
		working[count] = 0;
	}
	ybar = 0;
	for(count = 0; count < length; count++)
	{
		working[count] = *(bigmatrix + count + (numbvars * length));
		ybar = ybar + working[count];
	}
	scratch = length;
	ybar = ybar / scratch;
	sst = 0;
	for(count = 0; count < length; count++)
	{
		sst = sst + ((working[count] - ybar) * (working[count] - ybar));
	}
	for(count = 0; count < MAX_OBS; count++)
	{
		fitted[count] = 0;
	}
	for(count = 0; count < length; count++)
	{
		scratch = theintercept;
		for(countt = 1; countt < numbvars; countt++)
		{
			scratch = scratch + *(bigmatrix + count + (countt * length)) * coefs[countt];
		}
		fitted[count] = scratch;
	}
	ssr = 0;
	for(count = 0; count < length; count++)
	{
		ssr = ssr + ((fitted[count] - ybar) * (fitted[count] - ybar));
	}
	saystatus("Displaying Results ");
	wprintw(ioarea,"\n\n");
	wrefresh(ioarea);
	wprintw(ioarea," Source   |     SS            df           MS      \n");
	wrefresh(ioarea);
	wprintw(ioarea," ---------+--------------------------------------   Number of obs = %6i\n", length);
	wrefresh(ioarea);
	wprintw(ioarea," Model    | %13.3f %6i   %13.3f    F(%4i,%4i)  = %6.2f\n", ssr, (numbvars - 1), ssr / (numbvars - 1),(numbvars - 1), length - numbvars, ((ssr/(numbvars - 1)) / ((sst - ssr) / (length - numbvars))));   
	wrefresh(ioarea);
	wprintw(ioarea," Residual | %13.3f %6i   %13.3f    R-square      = %6.4f\n", sst - ssr, length - numbvars, (sst - ssr) / (length - numbvars), ssr / sst);
	wrefresh(ioarea);
	scratch = numbvars - 1;
	scratch = scratch / (length - 1);
	scratch = scratch * (1 - (ssr/sst));
	wprintw(ioarea," ---------+--------------------------------------   Adj R-square  = %6.4f\n", (ssr/sst) - scratch);
	wrefresh(ioarea);
	wprintw(ioarea," Total    | %13.3f %6i   %13.3f    Root MSE      = %6.4f\n", sst, length - 1, sst / (length - 1), sqrt((sst - ssr) / (length - numbvars)));
	wrefresh(ioarea);
	wprintw(ioarea,"                                                                    \n");
	wrefresh(ioarea);
	wprintw(ioarea," Variable |    Coefficient         Std. Error        t               Mean \n");
	wrefresh(ioarea);
	wprintw(ioarea," ---------+-----------------------------------------------------------------\n");
	wrefresh(ioarea);
	wprintw(ioarea," %8s |                                                  %13f\n", varname[numbvars], ybar);
	wrefresh(ioarea);
	wprintw(ioarea," ---------+-----------------------------------------------------------------\n");
	wrefresh(ioarea);
	wprintw(ioarea," (intcpt) | %13f \n",coefs[0]);
	wrefresh(ioarea);
	wprintw(ioarea," ---------+-----------------------------------------------------------------\n");
	wrefresh(ioarea);
	mse = ((sst - ssr) / (length - numbvars));
	more = 14;
	for(count = 1; count < numbvars; count++)
	{
		scratch = 0;
		xbar = 0;
		for(countt = 0; countt < length; countt++)
		{
			working[countt] = *(bigmatrix + countt + (count * length));
			xbar = xbar + working[countt];
		}
		xbar = xbar / length;
		for(countt = 0; countt < length; countt++)
		{
			scratch = scratch + ((working[countt] - xbar) * (working[countt] - xbar));
		}
		wprintw(ioarea," %8s | %13f      %13f      %6.3f      %13f\n", varname[count], coefs[count], sqrt(mse/scratch), coefs[count] / (sqrt(mse/scratch)), xbar);
		wrefresh(ioarea);
		more = check_more(more);
	}
	wprintw(ioarea," ---------+-----------------------------------------------------------------\n");
	wrefresh(ioarea);
	if(existslog == TRUE) 
	{
		fprintf(log_name,"\n\n");
		fprintf(log_name," Source   |     SS            df           MS      \n");
		fprintf(log_name," ---------+--------------------------------------   Number of obs = %6i\n", length);
		fprintf(log_name," Model    | %13.3f %6i   %13.3f    F(%4i,%4i)  = %6.2f\n", ssr, (numbvars - 1), ssr / (numbvars - 1),(numbvars - 1), length - numbvars, ((ssr/(numbvars - 1)) / ((sst - ssr) / (length - numbvars))));   
		fprintf(log_name," Residual | %13.3f %6i   %13.3f    R-square      = %6.4f\n", sst - ssr, length - numbvars, (sst - ssr) / (length - numbvars), ssr / sst);
		scratch = numbvars - 1;
		scratch = scratch / (length - 1);
		scratch = scratch * (1 - (ssr/sst));
		fprintf(log_name," ---------+--------------------------------------   Adj R-square  = %6.4f\n", (ssr/sst) - scratch);
		fprintf(log_name," Total    | %13.3f %6i   %13.3f    Root MSE      = %6.4f\n", sst, length - 1, sst / (length - 1), sqrt((sst - ssr) / (length - numbvars)));
		fprintf(log_name,"                                                                    \n");
		fprintf(log_name," Variable |    Coefficient         Std. Error        t               Mean \n");
		fprintf(log_name," ---------+-----------------------------------------------------------------\n");
		fprintf(log_name," %8s |                                                  %13f\n", varname[numbvars], ybar);
		fprintf(log_name," ---------+-----------------------------------------------------------------\n");
		fprintf(log_name," (intcpt) | %13f \n",coefs[0]);
		fprintf(log_name," ---------+-----------------------------------------------------------------\n");
		mse = ((sst - ssr) / (length - numbvars));
		for(count = 1; count < numbvars; count++)
		{
			scratch = 0;
			xbar = 0;
			for(countt = 0; countt < length; countt++)
			{
				working[countt] = *(bigmatrix + countt + (count * length));
				xbar = xbar + working[countt];
			}
			xbar = xbar / length;
			for(countt = 0; countt < length; countt++)
			{
				scratch = scratch + ((working[countt] - xbar) * (working[countt] - xbar));
			}
			fprintf(log_name," %8s | %13f      %13f      %6.3f      %13f\n", varname[count], coefs[count], sqrt(mse/scratch), coefs[count] / (sqrt(mse/scratch)), xbar);
		}
		fprintf(log_name," ---------+-----------------------------------------------------------------\n");
	}
	if(existstex == TRUE) 
	{
		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"\n\n\\midinsert\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#&\\strut\\quad\\hfil#\\quad\\cr\n");
		fprintf(tex_name,"\n");
		fprintf(tex_name,"& Number of Observations && %i  &\\cr\n", length);
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&               F(%i,%i) && %f  &\\cr\n", (numbvars - 1), length - numbvars, ((ssr/(numbvars - 1)) / ((sst - ssr) / (length - numbvars))));
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&               R-square && %f  &\\cr\n", ssr / sst);
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		scratch = numbvars - 1;
		scratch = scratch / (length - 1);
		scratch = scratch * (1 - (ssr/sst));
		fprintf(tex_name,"& Adjusted R-square      && %f  &\\cr\n", ((ssr/sst) - scratch));
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&               Root MSE && %f  &\\cr\n", sqrt((sst - ssr) / (length - numbvars)));
		fprintf(tex_name,"}\\hrule}$$\n");

		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#&\\strut\\quad\\hfil#\\quad\\cr\n");
		fprintf(tex_name,"\n");
		fprintf(tex_name,"&       Source &&  SS\\hfil  && df   &&     MS\\hfil&\\cr\n");
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&       Model  &&  %f  && %i   &&  %f &\\cr\n", ssr, (numbvars - 1), ssr / (numbvars - 1));
		fprintf(tex_name,"&    Residual  &&  %f  && %i   &&  %f &\\cr\n", sst - ssr, length - numbvars, (sst - ssr) / (length - numbvars));
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&      Total   &&  %f  && %i   &&  %f &\\cr\n", sst, length - 1, sst / (length - 1));
		fprintf(tex_name,"}\\hrule}$$\n");

		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#&\\strut\\quad\\hfil#\\quad\\cr\n");
		fprintf(tex_name,"\n");
		fprintf(tex_name,"&     Variable &&  Coefficient  && Standard Error   &&    t \\hfil&& Mean\\hfil &\\cr\n");
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&        %s    &&               &&                  &&      && %f   &\\cr\n",varname[numbvars], ybar);
		fprintf(tex_name,"&  (intrcpt)   &&           %f  &&                  &&      &&      &\\cr\n",coefs[0]);
		mse = ((sst - ssr) / (length - numbvars));
		for(count = 1; count < numbvars; count++)
		{
			scratch = 0;
			xbar = 0;
			for(countt = 0; countt < length; countt++)
			{
				working[countt] = *(bigmatrix + countt + (count * length));
				xbar = xbar + working[countt];
			}
			xbar = xbar / length;
			for(countt = 0; countt < length; countt++)
			{
				scratch = scratch + ((working[countt] - xbar) * (working[countt] - xbar));
			}
			fprintf(tex_name,"& %8s && %13f && %13f && %6.3f  && %13f &\\cr\n", varname[count], coefs[count], sqrt(mse/scratch), coefs[count] / (sqrt(mse/scratch)), xbar);
		}
		fprintf(tex_name,"}\\hrule}$$\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"\\endinsert\n");
	}
	free(matrix);
	free(bigmatrix);
}

void ldpredict(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT];
	char tokent[MAX_INPUT];
	int count, countt, vnum, f_numb, biggest;
	float scratch;
	strcpy(token,puller(coinput));
	if(token[0] < 65 || token[0] > 122)
	{
		alert(error(53), alert_time);
		return;
	}
	if(token[0] > 90 && token[0] < 97)
	{
		alert(error(53), alert_time);
		return;
	}
	if(checkname(token) < 0)
	{
		alert(error(14),alert_time);
		return;
	}
	vnum = findempty();
	if(vnum < 0)
	{
		alert(error(3),alert_time);
		return;
	}
	f_numb = typeaug(1,vnum);
	fvec[f_numb] = (double *) malloc (MAX_OBS * sizeof(double));
	if (!fvec[f_numb])
	{
		alert(error(4),alert_time);
		return;
	}
	saystatus("Fitting Values...  ");
	strcpy(d_matrix[vnum].v_name,token);
	d_matrix[vnum].fnumb = f_numb;
	d_matrix[vnum].fmem_start=fvec[f_numb];
	biggest = 0;
	for(count = 0; count < MAX_VARS; count++)
	{
		if(inreglist[count] == TRUE)
		{
			if(biggest < d_matrix[count].nobs) biggest = d_matrix[count].nobs;
		}
	}
	if(biggest < 1)
	{
		strcpy(d_matrix[vnum].v_name,"\0");
		d_matrix[vnum].fnumb = -1;
		flushempty();
		alert(error(74), alert_time);
		return;
	}
	astart = 1;
	astop = biggest;
	strcpy(token,puller(coinput));
	if(strlen(token) > 0)
	{
		if(strncmp(token,"in") == 0)
		{
			astart = atoi(puller(coinput));
			astop = atoi(puller(coinput));
			if(astart < 1) astart = 1;
			if(astop > biggest) astop = biggest;
			if(astop < 1) astop = 1;
			if(astop < astart) astop = astart;
		}
	}
	for(count = 0; count < MAX_VARS; count++)
	{
		if(d_matrix[count].fnumb != -1)
		{
			fvec[d_matrix[count].fnumb] = d_matrix[count].fmem_start;
		}
		if(d_matrix[count].inumb != -1)
		{
			ivec[d_matrix[count].inumb] = d_matrix[count].imem_start;
		}
	}
	for(count = 0; count < astart - 1; count++)
	{
		*fvec[f_numb] = missing_ob;
		fvec[f_numb]++;
	}
	for(count = astart - 1; count < astop; count ++)
	{
		scratch = theintercept;
		for(countt = 0; countt < MAX_VARS; countt++)
		{
			if(inreglist[countt] == TRUE && scratch != missing_ob)
			{
				if(d_matrix[countt].fnumb != -1)
				{
					if(*(fvec[d_matrix[countt].fnumb] + count) == missing_ob)
					{
						scratch = missing_ob;
					}
					else
					{
						scratch = scratch + ( *(fvec[d_matrix[countt].fnumb] + count) * reglist[countt]);
					}
				}
				if(d_matrix[countt].inumb != -1)
				{
					if(*(ivec[d_matrix[countt].inumb] + count) == missing_ob)
					{
						scratch = missing_ob;
					}
					else
					{
						scratch = scratch + ( *(ivec[d_matrix[countt].inumb] + count) * reglist[countt]);
					}
				}
			}
		}
		*fvec[f_numb] = scratch;
		fvec[f_numb]++;
	}
	d_matrix[vnum].nobs=astop;
	oktoquit=FALSE;
}

/*
void extrap(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT];
	int source, target, count, scount, countt, length;
	int sourcetype, vnum;
	int numblags, numbobs;
	double *bigmatrix;
	double *matrix;
	saystatus("Extrapolating ...  ");
	strcpy(token,puller(coinput));
	for(count= 0; count < MAX_VARS; count++)
	{
		if(strcmp(d_matrix[count].v_name,token) == 0)
		{
			if(d_matrix[count].fnumb != -1) 
			{
				sourcetype = 1;
				source = d_matrix[count].fnumb;
				fvec[d_matrix[source].fnumb] = d_matrix[count].fmem_start;
				length = d_matrix[count].nobs;
			}
			if(d_matrix[count].inumb != -1)
			{
				sourcetype = 2;
				source = d_matrix[count].inumb;
				ivec[d_matrix[source].inumb] = d_matrix[count].imem_start;
				length = d_matrix[count].nobs;
			}
			if(d_matrix[count].snumb != -1)
			{
				alert(error(76), alert_time);
				return;
			}
			count = MAX_VARS + 1;
		}
	}
	if(count < MAX_VARS + 1)
	{
		alert(error(77), alert_time);
		return;
	}
	numblags = atoi(puller(coinput));
	if(numblags < 1)
	{
		alert(error(77), alert_time);
		return;
	}
	vnum = findempty();
	if(vnum < 0)
	{
		alert(error(3),alert_time);
		return;
	}
	strcpy(token,puller(coinput));
	numbobs = atoi(puller(coinput));
	if(numbobs < 1)
	{
		alert(error(67), alert_time);
		return;
	}
	if(strlen(token) < 1)
	{
		alert(error(69), alert_time);
		return;
	}
	if(token[0] < 65 || token[0] > 122)
	{
		alert(error(53), alert_time);
		return;
	}
	if(token[0] > 90 && token[0] < 97)
	{
		alert(error(53), alert_time);
		return;
	}
	if(checkname(token) < 0)
	{
		alert(error(14),alert_time);
		return;
	}
	astart = 1;
	strcpy(token,puller(coinput));
	if(strcmp(token,"in") == 0)
	{
		astart = atoi(puller(coinput));
		astop = atoi(puller(coinput));
		if(astart < 1) astart = 1;
		if(astop < 1) astop = 1;
		if(astop < astart)
		{
			astop = astart;
			length = 1;
		}
		length = (astop - astart) + 1;
	}
	if(length - numblags < 1)
	{
		alert(error(78), alert_time);
		return;
	}
	target = typeaug(1,vnum);
	fvec[target] = (double *) malloc (MAX_OBS * sizeof(double));
	if (!fvec[target])
	{
		alert(error(4),alert_time);
		return;
	}
	strcpy(d_matrix[vnum].v_name,token);
	d_matrix[vnum].fnumb = target;
	d_matrix[vnum].fmem_start=fvec[target];
	bigmatrix = (double *) malloc ((length * numblags) * sizeof (double));
	if(!bigmatrix)
	{
		alert(error(64), alert_time);
		return;
	}
	for(count = 0; count < numblags * length; count++)
	{
		*(bigmatrix + count) = missing_ob;
	}
	for(count = 0; count < length; count++)
	{
		if(sourcetype == 1)
		{
			*(bigmatrix + count) = *(fvec[source] + (astart - 1) + count);
		}
		if(sourcetype == 2)
		{
			*(bigmatrix + count) = *(ivec[source] + (astart - 1) + count);
		}
	}
	for(scount = 0; scount < numblags - 1; scount++)
	{
		for(count = scount + 1; count < length; count++)
		{
			*(bigmatrix + (scount * (numblags + 1)) + count) = *(bigmatrix + (scount * numblags) + count - 1);
		}
	}
	saystatus("Zapping Missings...");
	for(count = 0; count < length * numblags; count ++)
	{
		if(*(bigmatrix + count) == missing_ob)
		{
			column = count % length;
			for(countt = numblags; countt >= 0; countt--)
			{
				for(counts = (countt * length) + column; counts < (length * (numblags + 1)) - 1; counts++)
				{
					*(bigmatrix + counts) = *(bigmatrix + counts + 1);
				}
			}
			count = 0;
			length--;
			if(length <= numblags)
			{
				alert(error(66),alert_time);
				free(bigmatrix);
				return;
			}
		}	
	}
	wprintw(ioarea,"\n The bigmatrix is:\n");
	wrefresh(ioarea);
	for(count = 0; count < numblags * length; count++)
	{
		wprintw(ioarea,"%f \t", *(bigmatrix + count));
		wrefresh(ioarea);
	}
	free(bigmatrix);
}
*/
