/*      setsate.h  

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file includes routines to set up and shutdown
	the display:
	
		startup()	Start up screen mode, output thought of
				the day, etc.
				
		shutdown()	Clear out all the screens/windows for a
				clean exit back to the user's shell.
		
		alert(message)	A function which opens a centred windows
				and displays a message. Used for quote of
				the day and error messages. The output in
				alert() is _not_ echoed to the log file.
	
*/

int ldwait(void)
{
	int escape;
	char whatchar;
	escape = 0;
	wtimeout(ioarea,0);
	do
	{
		whatchar = wgetch(ioarea);
		if(whatchar > 0) escape = 1;
		if(ask_more == FALSE) escape = 1;
	}
	while(escape == 0);
	wrefresh(ioarea);
	if(strlen(coinput) > 0) small_error(3);
	if(whatchar == ' ') return(0);
	if(whatchar == '\n') return(0);
	return(1);
}

void alert(char *saywhat,int howlong)
{
	WINDOW *outline;
	WINDOW *textbox;
	outline=newwin(8,60,10,(COLS-20)/2-20);
	wstandout(outline);
	box(outline,0,0);
	wstandend(outline);
	wrefresh(outline);
	textbox=newwin(4,56,12,((COLS-20)/2)-18);
	wtimeout(textbox,0);
	waddstr(textbox,saywhat);
	wrefresh(textbox);
	keypad(textbox,1);
	ldwait();
	wclear(textbox);
	wclear(outline);
	wrefresh(textbox);
	wrefresh(outline);	
	delwin(textbox);
	delwin(outline);
	refresh();
}	

void shutdown(void)
{
	if(COLS < MIN_COLS || LINES < MIN_LINES) return;
	wattroff(statusbar,A_REVERSE);
	wclear(statusbar);
	wclear(ioarea);
	wrefresh(statusbar);
	wrefresh(ioarea);
	endwin();
	if(existslog == TRUE) fclose(log_name);
	if(existstex == TRUE) fclose(tex_name);
}

char *randmessage(void)
{
	int hmm;
	srand(time());
	hmm = rand() % 34;
	switch (hmm)
	{
/*  template:                    B                                                      EB                                                      EB                                                      EB                                                      E*/
		case 0 : return("To express anything important in mere figures is so     plainly impossible that there must be endless scope for well paid advice on how to do it.                            --Manderville\0");break;
		case 1 : return("But when the statistical cook turns to raw materials ...he substitutes green garment die for curry, ping-pong   balls for turtle's eggs, and, for Chalifougnac vintage  1883, a can of turpentine. --Valavanis\0"); break;
		case 2 : return("Hendry notes that the word econometrics should not be   confused with ``economystics,'' ``economic-tricks,'' or ``icon-ometrics.''                                           --Kennedy\0");break;
		case 3 : return("All econometric models break down when used for policy.                                                                                                                      --Goodhart's Law\0");break;
		case 4 : return("Regressions on government-collected data have been used mainly to bolster one theoretical argument over another.But the bolstering they provide is weak, ...  and easilycountered by someone else's regressions. --Bergmann\0");break;
		case 5 : return("[Econometrics is] the art of drawing a crooked line froman unproved assumption to a foregone conclusion.                                                                     --Kennedy\0");break;
		case 6 : return("But what you must never forget is that every one of     those figure comes in the first instance from the       village watchman, who just puts down what he damn       pleases. --Stamp\0");break;
		case 7 : return("If an economist is someone who guesses wrong about the  economy, an econometrician is someone who uses a        computer to guess wrong about the economy.                   --Kennedy\0");break;
		case 8 : return("[Forecasters] only forecast to show the world that we   have a sense of humour.                                                                                              --Kennedy\0");break;
		case 9 : return("One of the great mistakes of the past 30 years of       economic policy has been an excessive belief in the     ability to forecast.                                         --Feldstein\0");break;
		case 10: return("... in no other field of empirical enquiry has so       massive and sophisticated a statistical machinery been  used with such indifferent results [as in economics].        --Leontief\0");break;
		case 11: return("There are three kinds of lies: lies, damned lies, and   statistics.                                                                                                          --Disraeli\0");break;
		case 12: return("Statistical thinking will one day be as necessary for   efficient citizenship as the ability to read and write.                                                              --Wells\0");break;
		case 13: return("Round numbers are always false.                                                                                                                                              --Johnson\0");break;
		case 14: return("Averages and relationships and trends and graphs are notalways what they seem. There may be more in them than   meets the eye, and there may be a good deal less.            --Huff\0");break;
		case 15: return("A well-wrapped statistic is better than Hitler's ``big  lie''; it misleads, yet it cannot be pinned on you.                                                                  --Huff\0");break;
		case 16: return("If you have a barrel of beans, some red and some white, there is only one way to find out exactly how many of   each color you have: Count 'em.                              --Huff\0");break;
		case 17: return("As [is] usually true with income figures, an unqualified``average'' is virtually meaningless.                                                                                --Huff\0");break;
		case 18: return("If you work half-time one year and full-time the next,  your earnings will double, but that doesn't indicate    anything at all about your wage rate.                        --Huff\0");break;
		case 19: return("I have just tried ten tosses and got heads eight times, which proves that pennies come up heads eighty percent  of the time.                                                 --Huff\0");break;
		case 20: return("Your probably guessed I just made up [$60] for purposes of illustration, but I'll bet you wouldn't have if I'd  used $59.83 instead.                                         --Huff\0");break;
		case 21: return("You can, for instance, express exactly the same fact by calling it a 1% return on sales, a 15% return on        investment, a 10 million dollar profit, or a decrease ofsixty percent from last year. --Huff\0");break;
		case 22: return("The above data, which may be relied upon, were given to me by a Manchester spinner.                                                                                          --Marx\0");break;
		case 23: return("Buy your Christmas presents now and save 100 percent.                                                                                                                        --Advertisement\0");break;
		case 24: return("[workers] affiliated with the Indianapolis Building     Trade Unions were given a 5% increase in wages. That    gave back to the men one fourth of the 20% cut they tooklast winter. --New York Times\0");break;
		case 25: return("The average Welshman has more than the average number oflegs.                                                                                                                --Baker\0");break;
		case 26: return("Introspection is the most important empirical tool.                                                                                                                          --Hogan\0");break;
		case 27: return("Platykurtic [distributions] have short tails like a     platypus, while leptokurtic [distributions] have long   tails like kangaroos, noted for ``lepping''.                 --Gosset\0");break;
		case 28: return("Now matter how well you estimate the Bayesian           probabilities, you should recognize that these values   are neither intuitively obvious nor even readily        obtained.   --Harnett\0");break;
		case 29: return("When the emphasis is upon the use of numerical facts    without a careful consideration of the methods of       collection and interpretation, then statistical data canbecome all things to all men. --Rosander\0");break;
		case 30: return("``Facts'' are conditioned by, and are a product of,     the particular process used to obtain them.                                                                          --Rosander\0");break;
		case 31: return("``Facts'' may be distorted by the prejudices of the     persons who collect, select, and publish them.                                                                       --Rosander\0");break;
		case 32: return("If you believe [econometricians], then you also believe in the tooth fairy.                                                                                                  --Regan\0");break;
		case 33: return("All macroeconomic variables are random walks.                                                                                                                                --Ragan\0");break;
	}
}
		

int startup(void)
{
	initscr();
	if(COLS < MIN_COLS || LINES < MIN_LINES)
	{
		endwin();
		beep();
		printf("\n ERROR: ldlas cannot run in such a small terminal.\n\n");
		return(FALSE);
	}
	cbreak();
	timeout(0);
	statusbar=newwin(1,COLS,LINES-1,0);
	wattron(statusbar,A_REVERSE);
	wclear(statusbar);
	wrefresh(statusbar);
	wrefresh(statusbar);
	wprintw(statusbar,"ldlas %1.2f via %s",LDLAS_VER,longname());
	wrefresh(statusbar);
	ioarea=newwin(LINES-1,COLS,0,0);
	scrollok(ioarea,TRUE);
	leaveok(ioarea,FALSE);
	keypad(ioarea,TRUE);
	timeout(0);
	wmove(ioarea,LINES-2,0);
	wrefresh(ioarea);
	noecho();
	alert(randmessage(),alert_time);
	wrefresh(ioarea);
	return(TRUE);
}

void unmangle(void)
{
	WINDOW *clearout;
        int escape = 0;
        clearout = newwin(LINES,COLS,0,0);
        touchwin(clearout);
        wrefresh(clearout);
        werase(clearout);
        delwin(clearout);
	werase(stdscr);
	touchwin(stdscr);
	wrefresh(stdscr);
	werase(ioarea);
	touchwin(ioarea);
	wrefresh(ioarea);
	werase(statusbar);
	touchwin(statusbar);
	wrefresh(statusbar);
	wmove(statusbar,0,0);
	wprintw(statusbar,"ldlas Version %1.2f via %s",LDLAS_VER,longname());
	wmove(ioarea,LINES-2,0);
	wrefresh(statusbar);
	wrefresh(ioarea);
        wprintw(ioarea,"                                                                                "); 
        wrefresh(ioarea);
	do
	{
		wprintw(ioarea,"\n");
		wrefresh(ioarea);
		escape++;
	}
	while(escape <= LINES + 1);
	if(strlen(coinput) > 0) small_error(3);
}

