/*      stats.h  

	part of the ldlas package
	(c) 1995, 1996 by Thor Sigvaldason
	
	This file includes routines to do descriptive statistics
	
*/

void fsort(double *floatvec)
{
	int count, scount,tcount, escapesort;
	worksize = 0;
	escapesort = FALSE;
	for(count=0;count < astart; count++)
	{
		floatvec++;
	}
	for(count = astart; count < astop; count ++)
	{
		if( *floatvec != missing_ob)
		{
			scount = 0;
			worksize++;
			while(escapesort == FALSE)
			{
				scount++;
				if(*floatvec <= working[scount])
				{
					for(tcount=worksize;tcount>scount;tcount--)
					{
						working[tcount]=working[tcount-1];
					}
					working[scount]=*floatvec;
					escapesort = TRUE;
				}
				if(scount == worksize)
				{
					working[worksize]=*floatvec;
					escapesort = TRUE;
				}
			}
			escapesort=FALSE;
		}
	floatvec++;
	}
}

void isort(int *intvec)
{
	int count, scount,tcount, escapesort;
	worksize = 0;
	escapesort = FALSE;
	for(count=0;count < astart; count++)
	{
		intvec++;
	}
	for(count = astart; count < astop; count ++)
	{
		if( *intvec != missing_ob)
		{
			scount = 0;
			worksize++;
			while(escapesort == FALSE)
			{
				scount++;
				if(*intvec <= working[scount])
				{
					for(tcount=worksize;tcount>scount;tcount--)
					{
						working[tcount]=working[tcount-1];
					}
					working[scount]=*intvec;
					escapesort = TRUE;
				}
				if(scount == worksize)
				{
					working[worksize]=*intvec;
					escapesort = TRUE;
				}
			}
			escapesort=FALSE;
		}
	intvec++;
	}
}

void f_summ(int vnumo, int vnumt)
{
	int count, more, nrealobs;
	double running, runningt, smallest, largest, average, median, firstq, thirdq, variance;
	fvec[vnumo]=d_matrix[vnumt].fmem_start;
	more=0;
	nrealobs=0;
	running = 0;
	runningt = 0;
	astart = 0;
	astop = d_matrix[vnumt].nobs;
	check_in(coinput);
	if(astop > d_matrix[vnumt].nobs) astop = d_matrix[vnumt].nobs;
	for(count=0;count < astart; count++)
	{
		fvec[vnumo]++;
	}
	smallest = *fvec[vnumo];
	largest = *fvec[vnumo];
	for(count=astart;count < astop; count++)
	{
		if( *fvec[vnumo] != missing_ob)
		{
			running = running + *fvec[vnumo];
			runningt = runningt + (*fvec[vnumo] * *fvec[vnumo]);
			if(smallest > *fvec[vnumo] || smallest == missing_ob) smallest = *fvec[vnumo];
			if(largest < *fvec[vnumo] || largest == missing_ob) largest = *fvec[vnumo];
			nrealobs++;
		}
		fvec[vnumo]++;
	}
	average = running / nrealobs;
	variance = (runningt / nrealobs) - (average * average);
	fvec[vnumo]=d_matrix[vnumt].fmem_start;
	fsort(fvec[vnumo]);
	median = working[worksize / 2 + 1];
	if(nrealobs % 2 == 0) median = (working[worksize / 2] + working[worksize / 2 + 1]) / 2;
	firstq = working[(worksize + 1) / 4];
	thirdq = working[( 3 * (worksize + 1)) /4];
	if((nrealobs + 1) % 4 != 0)
	{
		firstq = working[(worksize + 1)/4] + .25 * (working[(((worksize + 1) / 4) + 1)] - working[(worksize + 1)/4]); 
		thirdq = working[(3*(worksize + 1)) /4] + .75 * (working[(((3* (worksize + 1)) / 4) + 1)] - working[(3 * (worksize + 1))/4]);
	}
	wprintw(ioarea,"\nSummary of %s between observation %i and %i\n",d_matrix[vnumt].v_name,astart+1,astop);
	wrefresh(ioarea);
	wprintw(ioarea,"-----------------------------------------------------\n");
	wrefresh(ioarea);
	wprintw(ioarea,"      Type of Variable: float\n");
	wrefresh(ioarea);
	wprintw(ioarea," Apparent Observations: %i\n",astop-astart);
	wrefresh(ioarea);
	wprintw(ioarea,"     Real Observations: %i\n",nrealobs);
	wrefresh(ioarea);
	wprintw(ioarea,"                   Sum: %10.6f\n",running);
	wrefresh(ioarea);
	wprintw(ioarea,"                  Mean: %10.6f\n",average);
	wrefresh(ioarea);
	wprintw(ioarea,"              Variance: %10.6f\n",variance);
	wrefresh(ioarea);
	wprintw(ioarea,"                Median: %10.6f\n",median);
	wrefresh(ioarea);
	wprintw(ioarea,"        First Quartile: %10.6f\n",firstq);
	wrefresh(ioarea);
	wprintw(ioarea,"        Third Quartile: %10.6f\n",thirdq);
	wrefresh(ioarea);
	wprintw(ioarea,"              Smallest: %10.6f\n",smallest);
	wrefresh(ioarea);
	wprintw(ioarea,"               Largest: %10.6f\n",largest);
	wrefresh(ioarea);
	wprintw(ioarea,"-----------------------------------------------------\n");
	wrefresh(ioarea);
	if(existslog == TRUE)
	{
		fprintf(log_name,"\n\nSummary of %s between observation %i and %i\n",d_matrix[vnumt].v_name,astart+1,astop);
		fprintf(log_name,"-----------------------------------------------------\n");
		fprintf(log_name,"      Type of Variable: float\n");
		fprintf(log_name," Apparent Observations: %i\n",astop-astart);
		fprintf(log_name,"     Real Observations: %i\n",nrealobs);
		fprintf(log_name,"                   Sum: %10.6f\n",running);
		fprintf(log_name,"                  Mean: %10.6f\n",average);
		fprintf(log_name,"              Variance: %10.6f\n",variance);
		fprintf(log_name,"                Median: %10.6f\n",median);
		fprintf(log_name,"        First Quartile: %10.6f\n",firstq);
		fprintf(log_name,"        Third Quartile: %10.6f\n",thirdq);
		fprintf(log_name,"              Smallest: %10.6f\n",smallest);
		fprintf(log_name,"               Largest: %10.6f\n",largest);
		fprintf(log_name,"-----------------------------------------------------\n");
	}
	if(existstex == TRUE)
	{
		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"\n\n\\midinsert\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"$$\\hbox{Summary of %s between Observation %i and %i}$$\n",d_matrix[vnumt].v_name,astart+1,astop);
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#&\\strut\\quad\\hfil#\\quad\\cr\n");
		fprintf(tex_name,"& Statistic\\hfil && Value \\hfil&\\cr\n");
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&      Type of Variable && float      &\\cr\n");
		fprintf(tex_name,"& Apparent Observations && %i         &\\cr\n",astop-astart);
		fprintf(tex_name,"&     Real Observations && %i         &\\cr\n",nrealobs);
		fprintf(tex_name,"&                   Sum && %10.6f     &\\cr\n",running);
		fprintf(tex_name,"&                  Mean && %10.6f     &\\cr\n",average);
		fprintf(tex_name,"&              Variance && %10.6f     &\\cr\n",variance);
		fprintf(tex_name,"&                Median && %10.6f     &\\cr\n",median);
		fprintf(tex_name,"&        First Quartile && %10.6f     &\\cr\n",firstq);
		fprintf(tex_name,"&        Third Quartile && %10.6f     &\\cr\n",thirdq);
		fprintf(tex_name,"&              Smallest && %10.6f     &\\cr\n",smallest);
		fprintf(tex_name,"&               Largest && %10.6f     &\\cr\n",largest);
		fprintf(tex_name,"}\\hrule}$$\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"\\endinsert\n\n");
	}
}

void i_summ(int vnumo, int vnumt)
{
	int count, more, nrealobs;
	double running, runningt, smallest, largest, average, median, firstq, thirdq, variance;
	ivec[vnumo]=d_matrix[vnumt].imem_start;
	more=0;
	nrealobs=0;
	running = 0;
	runningt = 0;
	astart = 0;
	astop = d_matrix[vnumt].nobs;
	check_in(coinput);
	if(astop > d_matrix[vnumt].nobs) astop = d_matrix[vnumt].nobs;
	for(count=0;count < astart; count++)
	{
		ivec[vnumo]++;
	}
	smallest = *ivec[vnumo];
	largest = *ivec[vnumo];
	for(count=astart;count < astop; count++)
	{
		if( *ivec[vnumo] != missing_ob)
		{
			running = running + *ivec[vnumo];
			runningt = runningt + (*ivec[vnumo] * *ivec[vnumo]);
			if(smallest > *ivec[vnumo] || smallest == missing_ob) smallest = *ivec[vnumo];
			if(largest < *ivec[vnumo] || largest == missing_ob) largest = *ivec[vnumo];
			nrealobs++;
		}
		ivec[vnumo]++;
	}
	average = running / nrealobs;
	variance = (runningt / nrealobs) - (average * average);
	ivec[vnumo]=d_matrix[vnumt].imem_start;
	isort(ivec[vnumo]);
	median = working[worksize / 2 + 1];
	if(nrealobs % 2 == 0) median = (working[worksize / 2] + working[worksize / 2 + 1]) / 2;
	firstq = working[(worksize + 1) / 4];
	thirdq = working[( 3 * (worksize + 1)) /4];
	if((nrealobs + 1) % 4 != 0)
	{
		firstq = working[(worksize + 1)/4] + .25 * (working[(((worksize + 1) / 4) + 1)] - working[(worksize + 1)/4]); 
		thirdq = working[(3*(worksize + 1)) /4] + .75 * (working[(((3* (worksize + 1)) / 4) + 1)] - working[(3 * (worksize + 1))/4]);
	}
	wprintw(ioarea,"\nSummary of %s between observation %i and %i\n",d_matrix[vnumt].v_name,astart+1,astop);
	wrefresh(ioarea);
	wprintw(ioarea,"-----------------------------------------------------\n");
	wrefresh(ioarea);
	wprintw(ioarea,"      Type of Variable: integer\n");
	wrefresh(ioarea);
	wprintw(ioarea," Apparent Observations: %i\n",astop-astart);
	wrefresh(ioarea);
	wprintw(ioarea,"     Real Observations: %i\n",nrealobs);
	wrefresh(ioarea);
	wprintw(ioarea,"                   Sum: %10.6f\n",running);
	wrefresh(ioarea);
	wprintw(ioarea,"                  Mean: %10.6f\n",average);
	wrefresh(ioarea);
	wprintw(ioarea,"              Variance: %10.6f\n",variance);
	wrefresh(ioarea);
	wprintw(ioarea,"                Median: %10.6f\n",median);
	wrefresh(ioarea);
	wprintw(ioarea,"        First Quartile: %10.6f\n",firstq);
	wrefresh(ioarea);
	wprintw(ioarea,"        Third Quartile: %10.6f\n",thirdq);
	wrefresh(ioarea);
	wprintw(ioarea,"              Smallest: %10.6f\n",smallest);
	wrefresh(ioarea);
	wprintw(ioarea,"               Largest: %10.6f\n",largest);
	wrefresh(ioarea);
	wprintw(ioarea,"-----------------------------------------------------\n");
	wrefresh(ioarea);
	if(existslog == TRUE)
	{
		fprintf(log_name,"\n\nSummary of %s between observation %i and %i\n",d_matrix[vnumt].v_name,astart+1,astop);
		fprintf(log_name,"-----------------------------------------------------\n");
		fprintf(log_name,"      Type of Variable: integer\n");
		fprintf(log_name," Apparent Observations: %i\n",astop-astart);
		fprintf(log_name,"     Real Observations: %i\n",nrealobs);
		fprintf(log_name,"                   Sum: %10.6f\n",running);
		fprintf(log_name,"                  Mean: %10.6f\n",average);
		fprintf(log_name,"              Variance: %10.6f\n",variance);
		fprintf(log_name,"                Median: %10.6f\n",median);
		fprintf(log_name,"        First Quartile: %10.6f\n",firstq);
		fprintf(log_name,"        Third Quartile: %10.6f\n",thirdq);
		fprintf(log_name,"              Smallest: %10.6f\n",smallest);
		fprintf(log_name,"               Largest: %10.6f\n",largest);
		fprintf(log_name,"-----------------------------------------------------\n");
	}
	if(existstex == TRUE)
	{
		fprintf(tex_name,"\n%%\n%%  The following table was created by ldlas\n%%\n");
		fprintf(tex_name,"\n\n\\midinsert\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"$$\\hbox{Summary of %s between Observation %i and %i}$$\n",d_matrix[vnumt].v_name,astart+1,astop);
		fprintf(tex_name,"$$\\vbox{\\offinterlineskip\n");
		fprintf(tex_name,"\\hrule\n");
		fprintf(tex_name,"\\halign{&\\vrule\\hfil#&\\strut\\quad\\hfil#\\quad\\cr\n");
		fprintf(tex_name,"& Statistic \\hfil&& Value \\hfil&\\cr\n");
		fprintf(tex_name,"\\noalign{\\hrule}\n");
		fprintf(tex_name,"&      Type of Variable && integer    &\\cr\n");
		fprintf(tex_name,"& Apparent Observations && %i         &\\cr\n",astop-astart);
		fprintf(tex_name,"&     Real Observations && %i         &\\cr\n",nrealobs);
		fprintf(tex_name,"&                   Sum && %10.6f     &\\cr\n",running);
		fprintf(tex_name,"&                  Mean && %10.6f     &\\cr\n",average);
		fprintf(tex_name,"&              Variance && %10.6f     &\\cr\n",variance);
		fprintf(tex_name,"&                Median && %10.6f     &\\cr\n",median);
		fprintf(tex_name,"&        First Quartile && %10.6f     &\\cr\n",firstq);
		fprintf(tex_name,"&        Third Quartile && %10.6f     &\\cr\n",thirdq);
		fprintf(tex_name,"&              Smallest && %10.6f     &\\cr\n",smallest);
		fprintf(tex_name,"&               Largest && %10.6f     &\\cr\n",largest);
		fprintf(tex_name,"}\\hrule}$$\n");
		fprintf(tex_name,"\\bigskip\n");
		fprintf(tex_name,"\\endinsert\n\n");
	}
}

void summary(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT];
	int count;	
	saystatus("Summarizing Data   ");
	strcpy(token,puller(coinput));
	if(strlen(token) < 1)
	{
		alert(error(2),alert_time);
		return;
	}
	for(count=0;count < MAX_VARS; count++)
	{
		if(strcmp(token,d_matrix[count].v_name)==0) 
		{
			wprintw(ioarea,"\n");
			wrefresh(ioarea);
			if(d_matrix[count].fnumb != -1)
			{
				f_summ(d_matrix[count].fnumb, count);
				if(strlen(puller(coinput)) > 0) small_error(3);
				return;
			}
			if(d_matrix[count].inumb != -1)
			{
				i_summ(d_matrix[count].inumb, count);
				if(strlen(puller(coinput)) > 0) small_error(3);
				return;
			}
			if(d_matrix[count].snumb != -1)
			{
				alert(error(15),alert_time);
				return;
			}
		alert(error(42),alert_time);
		}
	}
	alert(error(2),alert_time);
}
	
void ldrename(char coinput[MAX_INPUT])
{
	char token[MAX_INPUT];
	char tokent[MAX_INPUT];
	int count;	
	strcpy(token,puller(coinput));
	strcpy(tokent,puller(coinput));
	if(strlen(token) < 1)
	{
		alert(error(2),alert_time);
		return;
	}
	if(strlen(tokent) < 1)
	{
		alert(error(45), alert_time);
		return;
	}
	for(count=0;count < MAX_VARS; count++)
	{
		if(strcmp(tokent,d_matrix[count].v_name) == 0)
		{
			alert(error(46), alert_time);
			return;
		}
	}
	for(count=0;count < MAX_VARS; count++)
	{
		if(strcmp(token,d_matrix[count].v_name)==0) 
		{
			strcpy(d_matrix[count].v_name, tokent);
			count = MAX_VARS + 1;
			oktoquit = FALSE;
		}
	}
	if(count <= MAX_VARS + 1) alert(error(2), alert_time);
	if(strlen(puller(coinput)) > 0) small_error(3);
}

void finterp(int vnumber, int lims)
{
	int count, countt, match;
	int vnumo;
	int howmany;
	float begin, end;
	match = FALSE;
	vnumo = d_matrix[vnumber].fnumb;
	if(lims == FALSE)
	{
		astart = 0;
		astop = d_matrix[vnumber].nobs;
	}
	if(astart < 0) astart = 0;
	if(astop > d_matrix[vnumber].nobs) astop = d_matrix[vnumber].nobs;
	if(astop < astart)
	{
		alert(error(27), alert_time);
		return;
	}
	fvec[vnumo]=d_matrix[vnumber].fmem_start;
	for(count=0;count < astart; count++)
	{
		fvec[vnumo]++;
	}
	if(*fvec[vnumo] == missing_ob)
	{
		alert(error(56), alert_time);
		return;
	}
	for(count=astart; count < astop; count++)
	{
		fvec[vnumo]++;
		if(*fvec[vnumo] == missing_ob)
		{
			match = TRUE;
			fvec[vnumo]--;
			howmany = 0;
			begin = *fvec[vnumo];
			fvec[vnumo]++;
			while(*fvec[vnumo] == missing_ob)
			{
				howmany++;
				fvec[vnumo]++;
				count++;
				if(count == astop - 1)
				{
					alert(error(57), alert_time);
					return;
				}
			}
			end = *fvec[vnumo];
			for(countt = 0; countt < howmany; countt++)
			{
				fvec[vnumo]--;
			}
			for(countt = 0; countt < howmany; countt++)
			{
				*fvec[vnumo] = begin + (((end - begin) / (howmany + 1)) * (countt + 1));
				fvec[vnumo]++;
			}
		}
	}
	if(match == FALSE) alert(error(58), alert_time);
}

void iinterp(int vnumber, int lims)
{
	int count, countt, match;
	int vnumo;
	int howmany;
	float begin, end;
	match = FALSE;
	vnumo = d_matrix[vnumber].inumb;
	if(lims == FALSE)
	{
		astart = 0;
		astop = d_matrix[vnumber].nobs;
	}
	if(astart < 0) astart = 0;
	if(astop > d_matrix[vnumber].nobs) astop = d_matrix[vnumber].nobs;
	if(astop < astart)
	{
		alert(error(27), alert_time);
		return;
	}
	ivec[vnumo]=d_matrix[vnumber].imem_start;
	for(count=0;count < astart; count++)
	{
		ivec[vnumo]++;
	}
	if(*ivec[vnumo] == missing_ob)
	{
		alert(error(56), alert_time);
		return;
	}
	for(count=astart; count < astop; count++)
	{
		ivec[vnumo]++;
		if(*ivec[vnumo] == missing_ob)
		{
			match = TRUE;
			ivec[vnumo]--;
			howmany = 0;
			begin = *ivec[vnumo];
			ivec[vnumo]++;
			while(*ivec[vnumo] == missing_ob)
			{
				howmany++;
				ivec[vnumo]++;
				count++;
				if(count == astop - 1)
				{
					alert(error(57), alert_time);
					return;
				}
			}
			end = *ivec[vnumo];
			for(countt = 0; countt < howmany; countt++)
			{
				ivec[vnumo]--;
			}
			for(countt = 0; countt < howmany; countt++)
			{
				*ivec[vnumo] = begin + (((end - begin) / (howmany + 1)) * (countt + 1));
				ivec[vnumo]++;
			}
		}
	}
	if(match == FALSE) alert(error(58), alert_time);
}

void interp(char coinput[MAX_INPUT])
{
	int count;
	int lims;
	char token[MAX_INPUT];
	char tokent[MAX_INPUT];
	lims = FALSE;
	strcpy(token,puller(coinput));
	if(strlen(token) < 1)
	{
		alert(error(54), alert_time);
		return;
	}
	strcpy(tokent,puller(coinput));
	if(strncmp(tokent,"in",2) == 0)
	{
		lims = TRUE;
		astart = atoi(puller(coinput));
		astop = atoi(puller(coinput));
	}
	for(count = 0; count < MAX_VARS; count ++)
	{
		if(strcmp(token,d_matrix[count].v_name)==0) 
		{
			if(d_matrix[count].fnumb != -1)
			{
				finterp(count,lims);
				if(strlen(puller(coinput)) > 0) small_error(3);
				return;
			}
			if(d_matrix[count].inumb != -1)
			{
				iinterp(count,lims);
				if(strlen(puller(coinput)) > 0) small_error(3);
				return;
			}
			if(d_matrix[count].snumb != -1)
			{
				alert(error(55), alert_time);
				return;
			}
		}
	}
	alert(error(2), alert_time);
	if(strlen(puller(coinput)) > 0) small_error(3);
}

